-------- Documentation for dsmti version 3.1 --------

**********  Welcome to the DSM world.  **********

This is a package for full computations of  3-component
synthetic seismograms for a spherically symmetric TI
(transversely isoropic) earth model using the Direct
Solution Method.


CONFIGURATION:
        After editing environment variables in 'Makefile', type
	% make

USAGE:
	% dsmti < (parameter filename)

See 'USAGE' for details.

If you have any questions, requests or complaints, please feel
free to contact to
  takeuchi@eri.u-tokyo.ac.jp


						Nozomu Takeuchi

	program dsmti
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Computation of synthetic seismograms for spherical symmetric
c TI media by using the Direct Solution Method.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c constant
	integer maxngrid_r,maxlmax
	integer max_nstation,maxn_structure_zone,maxnfreq
	parameter ( maxngrid_r = 100000 )
	parameter ( maxlmax = 10000 )
	parameter ( max_nstation = 70 )
	parameter ( maxn_structure_zone = 15 )
	parameter ( maxnfreq = 8192 )
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c variables for time series
	integer n_frequency,i_frequency
	real*8 time_series_length,omega_imag
c variables for numerical grids
	integer ngrid_r0,lmin0,lmax0
	integer ngrid_r_estimated,ngrid_r,lmin,lmax,l
	integer n_frequency_band,i_frequency_band
	integer i_frequency_min,i_frequency_max
	real*8 grid_r(maxngrid_r)
	real*8 grid_rho(2,maxngrid_r)
	real*8 grid_Ak(2,maxngrid_r),grid_Am(2,maxngrid_r)
	real*8 grid_Ck(2,maxngrid_r),grid_Cm(2,maxngrid_r)
	real*8 grid_L(2,maxngrid_r),grid_N(2,maxngrid_r)
	real*8 grid_Fk(2,maxngrid_r),grid_Fm(2,maxngrid_r)
	real*8 grid_kappa(2,maxngrid_r)
	real*8 grid_mu(2,maxngrid_r)
	real*8 grid_qkappa(maxngrid_r)
	real*8 grid_qmu(maxngrid_r)
c variables for the structure
	integer n_structure_zone
	integer idim1_sph,idim2_sph,idim1_tor,idim2_tor
	real*8 rmin_structure_zone(maxn_structure_zone)
	real*8 rmax_structure_zone(maxn_structure_zone)
	real*8 rho_structure_zone(4,maxn_structure_zone)
	real*8 vpv_structure_zone(4,maxn_structure_zone)
	real*8 vph_structure_zone(4,maxn_structure_zone)
	real*8 vsv_structure_zone(4,maxn_structure_zone)
	real*8 vsh_structure_zone(4,maxn_structure_zone)
	real*8 eta_structure_zone(4,maxn_structure_zone)
	real*8 qkappa_structure_zone(maxn_structure_zone)
	real*8 qmu_structure_zone(maxn_structure_zone)
c variables for a source
	integer igrid_rs
	integer idim_rs_sph,idim_rs_tor,idim_rs_sph0,idim_rs_tor0
	real*8 source_r,source_mt(3,3)
	real*8 source_depth,source_lat,source_lon
	real*8 grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms
	real*8 grid_qkappas,grid_qmus
c variables for stations
	integer n_station
	integer idim_station_sph,idim_station_tor,
     &	        idim_station_sph0,idim_station_tor0
	real*8 station_lat(max_nstation),station_lon(max_nstation)
	real*8 station_theta(max_nstation),station_phi(max_nstation)
	complex*16 vecsph_sph1(3,0:maxlmax,-2:2,max_nstation)
	complex*16 vecsph_sph2(3,0:maxlmax,-2:2,max_nstation)
	complex*16 vecsph_tor(3,0:maxlmax,-2:2,max_nstation)
	complex*16 station_displacement(3,max_nstation,maxnfreq)
	character*80 sac_file(max_nstation)
c variables for matrix elements
	real*8 submatrix_I0(4,maxngrid_r)
	real*8 submatrix_I1k(4,maxngrid_r),submatrix_I1m(4,maxngrid_r)
	real*8 submatrix_I2(4,maxngrid_r)
	real*8 submatrix_I3k(4,maxngrid_r),submatrix_I3m(4,maxngrid_r)
	real*8 submatrix_I4(4,maxngrid_r)
	real*8 submatrix_I5k(4,maxngrid_r),submatrix_I5m(4,maxngrid_r)
	real*8 submatrix_I6(4,maxngrid_r)
	real*8 submatrix_I7(4,maxngrid_r)
	real*8 submatrix_I3k_mod(6,maxngrid_r)
	real*8 submatrix_I3m_mod(6,maxngrid_r)
	real*8 submatrix_I4_mod(6,maxngrid_r)
c variables for wavefield
	integer i_significance,idim0,init_npos_sph,init_npos_tor
	real*8 amp_max
	complex*16 omega
	complex*16 whole_matrix_sph(4,2*maxngrid_r)
	complex*16 whole_matrix_tor(2,maxngrid_r)
	complex*16 whole_matrix_dr_sph(2*maxngrid_r)
	complex*16 whole_matrix_dr_tor(maxngrid_r)
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
	complex*16 work_vector(2*maxngrid_r)
	real work_time(32*maxnfreq)
	complex*16 work_spc(16*maxnfreq)
	equivalence ( work_vector,work_spc )
c MPI variables
	include 'mpicom.h'
	integer info,irank,nsnd
c functions
	omega(time_series_length,i_frequency,omega_imag)
     &	  = dcmplx( 2.d0*pi*dble(i_frequency)/dble(time_series_length),
     &	            -omega_imag )
	ngrid_r_estimated
     &	  (i_frequency_band,n_frequency_band,ngrid_r0)
     &	  = int(
     &	      dnint (
     &	        ngrid_r0
     &	          * dble(i_frequency_band) / dble(n_frequency_band)
     &	      )
     &	    )
	lmin
     &	  (i_frequency_band,n_frequency_band,lmin0 )
     &    = lmin0
	lmax
     &	  (i_frequency_band,n_frequency_band,lmax0 )
     &	  = int(
     &	      dnint (
     &	        lmax0
     &	          * dble(i_frequency_band) / dble(n_frequency_band)
     &	      )
     &	    )
	i_frequency_min
     &	  (i_frequency_band,n_frequency_band,n_frequency)
     &	  = int(
     &	      dnint (
     &	        n_frequency
     &	          * dble(i_frequency_band-1) / dble(n_frequency_band)
     &	      )
     &	    ) + 1 - int(1.d0/dble(i_frequency_band))
	i_frequency_max
     &	  (i_frequency_band,n_frequency_band,n_frequency)
     &	  = int(
     &	      dnint (
     &	        n_frequency
     &	          * dble(i_frequency_band) / dble(n_frequency_band)
     &	      )
     &	    )
c
	data n_frequency_band / 4 /
c **********************************************************************
c inputing parameters
c **********************************************************************
c initialize MPI
	call minit
c
	if ( rank.eq.0 ) then
	  call param_input
     &	  ( maxngrid_r,maxlmax,max_nstation,maxn_structure_zone,
     &	    time_series_length,n_frequency,omega_imag,
     &	    ngrid_r0,lmin0,lmax0,
     &	    n_structure_zone,rmin_structure_zone,rmax_structure_zone,
     &	    rho_structure_zone,vpv_structure_zone,vph_structure_zone,
     &	    vsv_structure_zone,vsh_structure_zone,eta_structure_zone,
     &	    qkappa_structure_zone,qmu_structure_zone,
     &	    source_r,source_mt,source_depth,source_lat,source_lon,
     &	    n_station,station_lat,station_lon,
     &	    station_theta,station_phi,sac_file )
	  call msndi
	  call mputi( n_frequency,1,info )
	  call mputi( ngrid_r0,1,info )
	  call mputi( lmin0,1,info )
	  call mputi( lmax0,1,info )
	  call mputi( n_structure_zone,1,info )
	  call mputi( n_station,1,info )
	  call mputd( time_series_length,1,info )
	  call mputd( omega_imag,1,info )
	  call mputd( rmin_structure_zone,maxn_structure_zone,info )
	  call mputd( rmax_structure_zone,maxn_structure_zone,info )
	  call mputd( rho_structure_zone,4*maxn_structure_zone,info )
	  call mputd( vpv_structure_zone,4*maxn_structure_zone,info )
	  call mputd( vph_structure_zone,4*maxn_structure_zone,info )
	  call mputd( vsv_structure_zone,4*maxn_structure_zone,info )
	  call mputd( vsh_structure_zone,4*maxn_structure_zone,info )
	  call mputd( eta_structure_zone,4*maxn_structure_zone,info )
	  call mputd( qkappa_structure_zone,maxn_structure_zone,info )
	  call mputd( qmu_structure_zone,maxn_structure_zone,info )
	  call mputd( source_r,1,info )
	  call mputd( source_mt,9,info )
	  call mputd( station_theta,max_nstation,info )
	  call mputd( station_phi,max_nstation,info )
	  call msend( -1,10,info )
	else
	  call mrecv( 10,0,info )
	  call mgeti( n_frequency,1,info )
	  call mgeti( ngrid_r0,1,info )
	  call mgeti( lmin0,1,info )
	  call mgeti( lmax0,1,info )
	  call mgeti( n_structure_zone,1,info )
	  call mgeti( n_station,1,info )
	  call mgetd( time_series_length,1,info )
	  call mgetd( omega_imag,1,info )
	  call mgetd( rmin_structure_zone,maxn_structure_zone,info )
	  call mgetd( rmax_structure_zone,maxn_structure_zone,info )
	  call mgetd( rho_structure_zone,4*maxn_structure_zone,info )
	  call mgetd( vpv_structure_zone,4*maxn_structure_zone,info )
	  call mgetd( vph_structure_zone,4*maxn_structure_zone,info )
	  call mgetd( vsv_structure_zone,4*maxn_structure_zone,info )
	  call mgetd( vsh_structure_zone,4*maxn_structure_zone,info )
	  call mgetd( eta_structure_zone,4*maxn_structure_zone,info )
	  call mgetd( qkappa_structure_zone,maxn_structure_zone,info )
	  call mgetd( qmu_structure_zone,maxn_structure_zone,info )
	  call mgetd( source_r,1,info )
	  call mgetd( source_mt,9,info )
	  call mgetd( station_theta,max_nstation,info )
	  call mgetd( station_phi,max_nstation,info )
	endif
c
	call comp_vecsph_station
     &	  ( maxlmax,lmax0,n_station,station_theta,station_phi,
     &	    vecsph_sph1,vecsph_sph2,vecsph_tor )
c
	do 1000 i_frequency_band=1,n_frequency_band
c **********************************************************************
c generating numerical grids
c **********************************************************************
	  call grid_generation
     &	    ( maxngrid_r,ngrid_r_estimated
     &	        (i_frequency_band,n_frequency_band,ngrid_r0),
     &	      n_structure_zone,rmin_structure_zone,rmax_structure_zone,
     &	      vsv_structure_zone,vsh_structure_zone,
     &	      grid_r,source_r,ngrid_r )
	  call assign_structure
     &	    ( ngrid_r,grid_r,
     &	      n_structure_zone,rmin_structure_zone,rmax_structure_zone,
     &	      rho_structure_zone,
     &	      vpv_structure_zone,vph_structure_zone,
     &	      vsv_structure_zone,vsh_structure_zone,
     &	      eta_structure_zone,
     &	      qkappa_structure_zone,qmu_structure_zone,
     &	      grid_rho,grid_Ak,grid_Am,grid_Ck,grid_Cm,
     &	      grid_L,grid_N,grid_Fk,grid_Fm,
     &	      grid_kappa,grid_mu,grid_qkappa,grid_qmu,
     &	      idim1_sph,idim2_sph,idim1_tor,idim2_tor )
	  call assign_source
     &	    ( ngrid_r,grid_r,source_r,
     &	      grid_L,grid_Ck,grid_Cm,grid_Fk,grid_Fm,
     &	      grid_qkappa,grid_qmu,grid_mu,
     &	      igrid_rs,grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms,
     &	      grid_qkappas,grid_qmus,
     &	      idim_rs_sph,idim_rs_tor,idim_rs_sph0,idim_rs_tor0 )
	  call assign_station
     &	    ( ngrid_r,grid_r,grid_mu,
     &	      idim_station_sph,idim_station_tor,
     &	      idim_station_sph0,idim_station_tor0 )
c **********************************************************************
c computing submatrices for the elastic part of the medium
c **********************************************************************
	  call comp_submatrix
     &	    ( ngrid_r,grid_r,
     &	      grid_rho,grid_kappa,grid_mu,grid_Ak,grid_Am,
     &	      grid_Ck,grid_Cm,grid_L,grid_N,grid_Fk,grid_Fm,
     &	      submatrix_I0,submatrix_I1k,submatrix_I1m,submatrix_I2,
     &	      submatrix_I3k,submatrix_I3m,submatrix_I4,submatrix_I5k,
     &	      submatrix_I5m,submatrix_I6,submatrix_I7 )
	  call comp_submatrix_mod
     &	    ( ngrid_r,grid_r,
     &	      grid_rho,grid_kappa,grid_mu,
     &	      grid_Ak,grid_Am,grid_L,grid_N,grid_Fk,grid_Fm,
     &	      submatrix_I0,submatrix_I1k,submatrix_I3k,
     &	      submatrix_I3m,submatrix_I4,submatrix_I5k,
     &	      submatrix_I5m,submatrix_I6,submatrix_I7,
     &	      submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod )
c **********************************************************************
c **********************************************************************
c **********************************************************************
c computing wavefield for each frequency (for complex omega)
c **********************************************************************
c **********************************************************************
c **********************************************************************
	  do 200 i_frequency=i_frequency_min(i_frequency_band,
     &	                                     n_frequency_band,
     &	                                     n_frequency)
     &	                     +rank,
     &	                     i_frequency_max(i_frequency_band,
     &	                                     n_frequency_band,
     &	                                     n_frequency),
     &	                     size
c	    write(6,*) i_frequency,i_frequency_band,
c     &	               omega(time_series_length,i_frequency,omega_imag)
	   if ( i_frequency.ne.0 ) then
	    if ( i_frequency.gt.maxnfreq ) stop 'Too large i_freqnecy.'
	    call init_complex_array
     &	      ( 3*max_nstation,station_displacement(1,1,i_frequency) )
c
	    do 110 l=lmin(i_frequency_band,n_frequency_band,lmin0 ),
     &	             lmax(i_frequency_band,n_frequency_band,lmax0 )
c **********************************************************************
c computing the displacement and the traction at the boundary
c of the heterogeneous region.
c **********************************************************************
	      if ( l.eq.0 ) then
	        call comp_excitation0
     &	        ( maxngrid_r,
     &	          omega(time_series_length,i_frequency,omega_imag),
     &	          ngrid_r,grid_r,l,source_r,source_mt,
     &	          igrid_rs,grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms,
     &	          grid_qkappas,grid_qmus,
     &	          submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	          submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	          submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	          submatrix_I6,submatrix_I7,
     &	          submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	          idim_rs_sph0,idim_rs_tor0,
     &	          whole_vector_sph,whole_vector_tor )
	        call comp_wavefield0
     &	        ( maxngrid_r,
     &	          omega(time_series_length,i_frequency,omega_imag),
     &	          submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	          submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	          submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	          submatrix_I6,submatrix_I7,
     &	          submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	          ngrid_r,grid_r,grid_mu,grid_qkappa,grid_qmu,l,
     &	          idim1_sph,idim2_sph,idim1_tor,idim2_tor,
     &	          idim0,init_npos_sph,init_npos_tor,
     &	          idim_rs_sph0,idim_rs_tor0,
     &	          idim_station_sph0,idim_station_tor0,
     &	          whole_matrix_sph,whole_matrix_tor,
     &	          whole_matrix_dr_sph,whole_matrix_dr_tor,
     &	          whole_vector_sph,whole_vector_tor,work_vector )
	        call check_amp_significance
     &	        ( maxngrid_r,l,amp_max,i_significance,idim0,
     &	          init_npos_sph,init_npos_tor,
     &	          idim1_sph,idim2_sph,idim1_tor,idim2_tor,
     &	          grid_mu,idim_station_sph0,idim_station_tor0,
     &	          whole_vector_sph,whole_vector_tor,work_vector )
	        call comp_displacement_station0
     &	        ( maxngrid_r,maxlmax,
     &	          whole_vector_tor,whole_vector_sph,
     &	          l,n_station,station_theta,station_phi,
     &	          idim_station_sph0,idim_station_tor0,
     &	          vecsph_sph1,vecsph_sph2,vecsph_tor,
     &	          station_displacement(1,1,i_frequency) )
	      else
	        if ( i_significance.eq.1 ) then
	        call comp_excitation
     &	        ( maxngrid_r,
     &	          omega(time_series_length,i_frequency,omega_imag),
     &	          ngrid_r,grid_r,l,source_r,source_mt,
     &	          igrid_rs,grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms,
     &	          grid_qkappas,grid_qmus,
     &	          submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	          submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	          submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	          submatrix_I6,submatrix_I7,
     &	          submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	          idim_rs_sph,idim_rs_tor,
     &	          whole_vector_sph,whole_vector_tor )
	        call comp_wavefield
     &	        ( maxngrid_r,
     &	          omega(time_series_length,i_frequency,omega_imag),
     &	          submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	          submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	          submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	          submatrix_I6,submatrix_I7,
     &	          submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	          ngrid_r,grid_r,grid_mu,grid_qkappa,grid_qmu,l,
     &	          idim1_sph,idim2_sph,idim1_tor,idim2_tor,
     &	          idim0,init_npos_sph,init_npos_tor,
     &	          idim_rs_sph,idim_rs_tor,
     &	          idim_station_sph,idim_station_tor,
     &	          whole_matrix_sph,whole_matrix_tor,
     &	          whole_matrix_dr_sph,whole_matrix_dr_tor,
     &	          whole_vector_sph,whole_vector_tor,work_vector )
	        call check_amp_significance
     &	        ( maxngrid_r,l,amp_max,i_significance,idim0,
     &	          init_npos_sph,init_npos_tor,
     &	          idim1_sph,idim2_sph,idim1_tor,idim2_tor,
     &	          grid_mu,idim_station_sph,idim_station_tor,
     &	          whole_vector_sph,whole_vector_tor,work_vector )
	        call comp_displacement_station
     &	        ( maxngrid_r,maxlmax,
     &	          whole_vector_tor,whole_vector_sph,
     &	          l,n_station,station_theta,station_phi,
     &	          idim_station_sph,idim_station_tor,
     &	          vecsph_sph1,vecsph_sph2,vecsph_tor,
     &	          station_displacement(1,1,i_frequency) )
	        endif
	      endif
  110	    continue
	   endif
c **********************************************************************
c writing the result to the spectrum files
c **********************************************************************
c	   call write_sac_file
c     &	      ( i_frequency,n_station,sac_file,
c     &	        station_displacement )
  200	  continue
c
 1000	continue
c
	  nsnd = 2 * 3 * max_nstation
	  if ( rank.ne.0 ) then
	    call msndi
	    do 1030 i_frequency_band=1,n_frequency_band
	    do 1020 i_frequency=i_frequency_min(i_frequency_band,
     &	                                       n_frequency_band,
     &	                                       n_frequency)
     &	                       +rank,
     &	                       i_frequency_max(i_frequency_band,
     &	                                       n_frequency_band,
     &	                                       n_frequency),
     &	                       size
	      call mputd( station_displacement(1,1,i_frequency),
     &	                  nsnd,info )
 1020	    continue
 1030	    continue
	    call msend( 0,20,info )
	  else
	    do 1060 irank=1,size-1
	      call mrecv( 20,irank,info )
	      do 1050 i_frequency_band=1,n_frequency_band
	      do 1040 i_frequency=i_frequency_min(i_frequency_band,
     &	                                       n_frequency_band,
     &	                                       n_frequency)
     &	                       +irank,
     &	                       i_frequency_max(i_frequency_band,
     &	                                       n_frequency_band,
     &	                                       n_frequency),
     &	                       size
	        call mgetd( station_displacement(1,1,i_frequency),
     &	                    nsnd,info )
 1040	      continue
 1050	      continue
 1060	    continue
	  endif
 1100	continue
	if ( rank.eq.0 ) then
	  call convspc
     &	    ( max_nstation,maxnfreq,n_station,
     &	   time_series_length,n_frequency,omega_imag,
     &	   station_displacement,
     &	   source_depth,source_lat,source_lon,station_lat,station_lon,
     &	   work_spc,work_time,sac_file )
	endif
c
	call mpi_finalize( info )
c
	end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_excitation
     &	  ( maxngrid_r,omega,
     &	    ngrid_r,grid_r,l,source_r,source_mt,
     &	    igrid_rs,grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms,
     &	    grid_qkappas,grid_qmus,
     &	    submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	    submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	    submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	    submatrix_I6,submatrix_I7,
     &	    submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	    idim_rs_sph,idim_rs_tor,
     &	    whole_vector_sph,whole_vector_tor )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing a excitation vector for the given frequency.
c    required subroutines: error_handling
c    required functions: unelastic_factor
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,ngrid_r,l,igrid_rs
	integer idim_rs_sph,idim_rs_tor
	real*8 grid_r(*)
	real*8 source_r,source_mt(3,3)
	real*8 grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms
	real*8 grid_qkappas,grid_qmus
	real*8 submatrix_I0(4,maxngrid_r)
	real*8 submatrix_I1k(4,maxngrid_r),submatrix_I1m(4,maxngrid_r)
	real*8 submatrix_I2(4,maxngrid_r)
	real*8 submatrix_I3k(4,maxngrid_r),submatrix_I3m(4,maxngrid_r)
	real*8 submatrix_I4(4,maxngrid_r)
	real*8 submatrix_I5k(4,maxngrid_r),submatrix_I5m(4,maxngrid_r)
	real*8 submatrix_I6(4,maxngrid_r)
	real*8 submatrix_I7(4,maxngrid_r)
	real*8 submatrix_I3k_mod(6,maxngrid_r)
	real*8 submatrix_I3m_mod(6,maxngrid_r)
	real*8 submatrix_I4_mod(6,maxngrid_r)
	complex*16 omega
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
c other variables
	real*8 b1,b2,lsq2,lsq
	complex*16 D1,D2_p,D2_m,D3_p,D3_m,unelastic_factor
	complex*16 factors_qkappa,factors_qmu
c constant
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
	if ( l.le.0 ) call error_handling(51)
c **********************************************************************
c Initialing the whole_vector
c **********************************************************************
	call init_complex_array( 10*maxngrid_r,whole_vector_sph )
	call init_complex_array(  5*maxngrid_r,whole_vector_tor )
c **********************************************************************
c Computing the excitation vector
c **********************************************************************
	b1 = dsqrt( dble(2*l+1) / ( 16.d0 * pi ) )
	b2 = dsqrt( dble(2*l+1)*dble(l-1)*dble(l+2) / ( 64.d0 * pi ) )
	factors_qkappa = unelastic_factor( dble(omega), grid_qkappas )
	factors_qmu = unelastic_factor( dble(omega), grid_qmus )
	lsq2 = dble(l) * dble(l+1)
	lsq = dsqrt( lsq2 )
c --- spheroidal excitations due to the traction diccontinuities
	whole_vector_sph(idim_rs_sph,0)
     &	  = whole_vector_sph(idim_rs_sph,0)
     &	    - b1 * 2.d0
     &	      * ( source_mt(2,2) + source_mt(3,3)
     &	          - 2.d0 * source_mt(1,1)
     &	            * ( grid_Fks * factors_qkappa
     &	                + grid_Fms * factors_qmu )
     &	            / ( grid_Cks * factors_qkappa
     &	                + grid_Cms * factors_qmu )
     &	          ) / source_r
	whole_vector_sph(idim_rs_sph+1,0)
     &	  = whole_vector_sph(idim_rs_sph+1,0)
     &	    - b1 * lsq
     &	      * ( - source_mt(2,2) - source_mt(3,3)
     &	          + 2.d0 * source_mt(1,1)
     &	            * ( grid_Fks * factors_qkappa
     &	                + grid_Fms * factors_qmu )
     &	            / ( grid_Cks * factors_qkappa
     &	                + grid_Cms * factors_qmu )
     &	          ) / source_r
	whole_vector_sph(idim_rs_sph+1,-2)
     &	  = whole_vector_sph(idim_rs_sph+1,-2)
     &	    + b2
     &	      * dcmplx( - source_mt(2,2) + source_mt(3,3),
     &	                - 2.d0 * source_mt(2,3) )
     &	        / source_r
	whole_vector_sph(idim_rs_sph+1,2)
     &	  = whole_vector_sph(idim_rs_sph+1,2)
     &	    + b2
     &	      * dcmplx( - source_mt(2,2) + source_mt(3,3),
     &	                  2.d0 * source_mt(2,3) )
     &	        / source_r
c --- toroidal excitations due to the traction diccontinuities
	whole_vector_tor(idim_rs_tor,-2)
     &	  = whole_vector_tor(idim_rs_tor,-2)
     &	    - b2 * ( dcmplx( - 2.d0 * source_mt(2,3),
     &	                       source_mt(2,2) - source_mt(3,3) ) )
     &	      / source_r
	whole_vector_tor(idim_rs_tor,2)
     &	  = whole_vector_tor(idim_rs_tor,2)
     &	    - b2 * ( dcmplx( - 2.d0 * source_mt(2,3),
     &	                     - source_mt(2,2) + source_mt(3,3) ) )
     &	      / source_r
c --- excitations due to the displacement discontinuities
	D1 = b1 * 2.d0 * source_mt(1,1)
     &	     / ( source_r * source_r
     &	         * ( grid_Cks * factors_qkappa
     &	             + grid_Cms * factors_qmu )
     &	        )
	D2_p = b1 * dcmplx( -source_mt(1,2), source_mt(1,3) )
     &	     / ( source_r * source_r * grid_Ls * factors_qmu )
	D2_m = b1 * dcmplx( source_mt(1,2), source_mt(1,3) )
     &	     / ( source_r * source_r * grid_Ls * factors_qmu )
	D3_p = b1 * dcmplx( source_mt(1,3), source_mt(1,2) )
     &	     / ( source_r * source_r * grid_Ls * factors_qmu )
	D3_m = b1 * dcmplx( -source_mt(1,3), source_mt(1,2) )
     &	     / ( source_r * source_r * grid_Ls * factors_qmu )
c ---- spheroidal, m=0
	whole_vector_sph(idim_rs_sph,0)
     &	  = whole_vector_sph(idim_rs_sph,0)
     &	      + ( - omega * omega * submatrix_I0(1,igrid_rs)
     &	          + ( submatrix_I1k(1,igrid_rs)
     &	              + 4.d0 * submatrix_I3k(1,igrid_rs)
     &	              + 4.d0 * submatrix_I5k(1,igrid_rs)
     &	            ) * factors_qkappa
     &	          + ( submatrix_I1m(1,igrid_rs)
     &	              + 4.d0 * submatrix_I3m(1,igrid_rs)
     &	              + 4.d0 * submatrix_I5m(1,igrid_rs)
     &	              + lsq2 * submatrix_I6(1,igrid_rs)
     &	              - 4.d0 * submatrix_I7(1,igrid_rs)
     &	            ) * factors_qmu
     &	        ) * D1
	whole_vector_sph(idim_rs_sph+1,0)
     &	  = whole_vector_sph(idim_rs_sph+1,0)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(1,igrid_rs)
     &	                + 2.d0 * submatrix_I5k(1,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(1,igrid_rs)
     &	                  - submatrix_I4_mod(1,igrid_rs)
     &	                  + 2.d0 * submatrix_I5m(1,igrid_rs)
     &	                  + submatrix_I6(1,igrid_rs)
     &	                  - 2.d0 * submatrix_I7(1,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D1
	whole_vector_sph(idim_rs_sph+2,0)
     &	  = whole_vector_sph(idim_rs_sph+2,0)
     &	      + ( - omega * omega * submatrix_I0(3,igrid_rs)
     &	          + ( submatrix_I1k(3,igrid_rs)
     &	              + 2.d0 * submatrix_I3k(2,igrid_rs)
     &	              + 2.d0 * submatrix_I3k(3,igrid_rs)
     &	              + 4.d0 * submatrix_I5k(3,igrid_rs)
     &	            ) * factors_qkappa
     &	          + ( submatrix_I1m(3,igrid_rs)
     &	              + 2.d0 * submatrix_I3m(2,igrid_rs)
     &	              + 2.d0 * submatrix_I3m(3,igrid_rs)
     &	              + 4.d0 * submatrix_I5m(3,igrid_rs)
     &	              + lsq2 * submatrix_I6(3,igrid_rs)
     &	              - 4.d0 * submatrix_I7(3,igrid_rs)
     &	            ) * factors_qmu
     &	        ) * D1
	whole_vector_sph(idim_rs_sph+3,0)
     &	  = whole_vector_sph(idim_rs_sph+3,0)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(3,igrid_rs)
     &	                + 2.d0 * submatrix_I5k(3,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(3,igrid_rs)
     &	                  - submatrix_I4_mod(3,igrid_rs)
     &	                  + 2.d0 * submatrix_I5m(3,igrid_rs)
     &	                  + submatrix_I6(3,igrid_rs)
     &	                  - 2.d0 * submatrix_I7(3,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D1
c ---- spheroidal, m=-1
	whole_vector_sph(idim_rs_sph,-1)
     &	  = whole_vector_sph(idim_rs_sph,-1)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(1,igrid_rs)
     &	                + 2.d0 * submatrix_I5k(1,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(1,igrid_rs)
     &	                  - submatrix_I4_mod(1,igrid_rs)
     &	                  + 2.d0 * submatrix_I5m(1,igrid_rs)
     &	                  + submatrix_I6(1,igrid_rs)
     &	                  - 2.d0 * submatrix_I7(1,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D2_m
	whole_vector_sph(idim_rs_sph+1,-1)
     &	  = whole_vector_sph(idim_rs_sph+1,-1)
     &	      + ( - omega * omega * submatrix_I0(1,igrid_rs)
     &	          + ( lsq2 * submatrix_I5k(1,igrid_rs)
     &	            ) * factors_qkappa
     &	            + ( submatrix_I2(1,igrid_rs)
     &	                - 2.d0 * submatrix_I4(1,igrid_rs)
     &	                + lsq2 * submatrix_I5m(1,igrid_rs)
     &	                + submatrix_I6(1,igrid_rs)
     &	                - 2.d0 * submatrix_I7(1,igrid_rs)
     &	            ) * factors_qmu
     &	        )  * D2_m
	whole_vector_sph(idim_rs_sph+2,-1)
     &	  = whole_vector_sph(idim_rs_sph+2,-1)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(2,igrid_rs)
     &	                + 2.d0 * submatrix_I5k(3,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(2,igrid_rs)
     &	                  - submatrix_I4_mod(2,igrid_rs)
     &	                  + 2.d0 * submatrix_I5m(3,igrid_rs)
     &	                  + submatrix_I6(3,igrid_rs)
     &	                  - 2.d0 * submatrix_I7(3,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D2_m
	whole_vector_sph(idim_rs_sph+3,-1)
     &	  = whole_vector_sph(idim_rs_sph+3,-1)
     &	      + ( - omega * omega * submatrix_I0(3,igrid_rs)
     &	          + ( lsq2 * submatrix_I5k(3,igrid_rs)
     &	            ) * factors_qkappa
     &	            + ( submatrix_I2(3,igrid_rs)
     &	                - submatrix_I4(2,igrid_rs)
     &	                - submatrix_I4(3,igrid_rs)
     &	                + lsq2 * submatrix_I5m(3,igrid_rs)
     &	                + submatrix_I6(3,igrid_rs)
     &	                - 2.d0 * submatrix_I7(3,igrid_rs)
     &	            ) * factors_qmu
     &	        )  * D2_m
	whole_vector_sph(idim_rs_sph+4,-1)
     &	  = whole_vector_sph(idim_rs_sph+4,-1)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(5,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(5,igrid_rs)
     &	                  - submatrix_I4_mod(5,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D2_m
c ---- spheroidal, m=+1
	whole_vector_sph(idim_rs_sph,1)
     &	  = whole_vector_sph(idim_rs_sph,1)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(1,igrid_rs)
     &	                + 2.d0 * submatrix_I5k(1,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(1,igrid_rs)
     &	                  - submatrix_I4_mod(1,igrid_rs)
     &	                  + 2.d0 * submatrix_I5m(1,igrid_rs)
     &	                  + submatrix_I6(1,igrid_rs)
     &	                  - 2.d0 * submatrix_I7(1,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D2_p
	whole_vector_sph(idim_rs_sph+1,1)
     &	  = whole_vector_sph(idim_rs_sph+1,1)
     &	      + ( - omega * omega * submatrix_I0(1,igrid_rs)
     &	          + ( lsq2 * submatrix_I5k(1,igrid_rs)
     &	            ) * factors_qkappa
     &	            + ( submatrix_I2(1,igrid_rs)
     &	                - 2.d0 * submatrix_I4(1,igrid_rs)
     &	                + lsq2 * submatrix_I5m(1,igrid_rs)
     &	                + submatrix_I6(1,igrid_rs)
     &	                - 2.d0 * submatrix_I7(1,igrid_rs)
     &	            ) * factors_qmu
     &	        )  * D2_p
	whole_vector_sph(idim_rs_sph+2,1)
     &	  = whole_vector_sph(idim_rs_sph+2,1)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(2,igrid_rs)
     &	                + 2.d0 * submatrix_I5k(3,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(2,igrid_rs)
     &	                  - submatrix_I4_mod(2,igrid_rs)
     &	                  + 2.d0 * submatrix_I5m(3,igrid_rs)
     &	                  + submatrix_I6(3,igrid_rs)
     &	                  - 2.d0 * submatrix_I7(3,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D2_p
	whole_vector_sph(idim_rs_sph+3,1)
     &	  = whole_vector_sph(idim_rs_sph+3,1)
     &	      + ( - omega * omega * submatrix_I0(3,igrid_rs)
     &	          + ( lsq2 * submatrix_I5k(3,igrid_rs)
     &	            ) * factors_qkappa
     &	            + ( submatrix_I2(3,igrid_rs)
     &	                - submatrix_I4(2,igrid_rs)
     &	                - submatrix_I4(3,igrid_rs)
     &	                + lsq2 * submatrix_I5m(3,igrid_rs)
     &	                + submatrix_I6(3,igrid_rs)
     &	                - 2.d0 * submatrix_I7(3,igrid_rs)
     &	            ) * factors_qmu
     &	        )  * D2_p
	whole_vector_sph(idim_rs_sph+4,1)
     &	  = whole_vector_sph(idim_rs_sph+4,1)
     &	      + ( - lsq * (
     &	              ( submatrix_I3k_mod(5,igrid_rs)
     &	              ) * factors_qkappa
     &	              + ( submatrix_I3m_mod(5,igrid_rs)
     &	                  - submatrix_I4_mod(5,igrid_rs)
     &	              ) * factors_qmu
     &	        ) ) * D2_p
c ---- toroidal, m=-1
	whole_vector_tor(idim_rs_tor,-1)
     &	  = whole_vector_tor(idim_rs_tor,-1)
     &	      + ( - omega * omega * submatrix_I0(1,igrid_rs)
     &	          + ( submatrix_I2(1,igrid_rs)
     &	              - 2.d0 * submatrix_I4(1,igrid_rs)
     &	              + submatrix_I6(1,igrid_rs)
     &	              - ( lsq2 - 2.d0 ) * submatrix_I7(1,igrid_rs)
     &	             ) * factors_qmu
     &	         ) * D3_m
	whole_vector_tor(idim_rs_tor+1,-1)
     &	  = whole_vector_tor(idim_rs_tor+1,-1)
     &	      + ( - omega * omega * submatrix_I0(3,igrid_rs)
     &	          + ( submatrix_I2(3,igrid_rs)
     &	              - submatrix_I4(2,igrid_rs)
     &	              - submatrix_I4(3,igrid_rs)
     &	              + submatrix_I6(3,igrid_rs)
     &	              - ( lsq2 - 2.d0 ) * submatrix_I7(3,igrid_rs)
     &	             ) * factors_qmu
     &	         ) * D3_m
c ---- toroidal, m=+1
	whole_vector_tor(idim_rs_tor,1)
     &	  = whole_vector_tor(idim_rs_tor,1)
     &	      + ( - omega * omega * submatrix_I0(1,igrid_rs)
     &	          + ( submatrix_I2(1,igrid_rs)
     &	              - 2.d0 * submatrix_I4(1,igrid_rs)
     &	              + submatrix_I6(1,igrid_rs)
     &	              - ( lsq2 - 2.d0 ) * submatrix_I7(1,igrid_rs)
     &	             ) * factors_qmu
     &	         ) * D3_p
	whole_vector_tor(idim_rs_tor+1,1)
     &	  = whole_vector_tor(idim_rs_tor+1,1)
     &	      + ( - omega * omega * submatrix_I0(3,igrid_rs)
     &	          + ( submatrix_I2(3,igrid_rs)
     &	              - submatrix_I4(2,igrid_rs)
     &	              - submatrix_I4(3,igrid_rs)
     &	              + submatrix_I6(3,igrid_rs)
     &	              - ( lsq2 - 2.d0 ) * submatrix_I7(3,igrid_rs)
     &	             ) * factors_qmu
     &	         ) * D3_p
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_excitation0
     &	  ( maxngrid_r,omega,
     &	    ngrid_r,grid_r,l,source_r,source_mt,
     &	    igrid_rs,grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms,
     &	    grid_qkappas,grid_qmus,
     &	    submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	    submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	    submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	    submatrix_I6,submatrix_I7,
     &	    submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	    idim_rs_sph,idim_rs_tor,
     &	    whole_vector_sph,whole_vector_tor )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing a excitation vector for the given frequency.
c    required subroutines: error_handling
c    required functions: unelastic_factor
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,ngrid_r,l,igrid_rs
	integer idim_rs_sph,idim_rs_tor
	real*8 grid_r(*)
	real*8 source_r,source_mt(3,3)
	real*8 grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms
	real*8 grid_qkappas,grid_qmus
	real*8 submatrix_I0(4,maxngrid_r)
	real*8 submatrix_I1k(4,maxngrid_r),submatrix_I1m(4,maxngrid_r)
	real*8 submatrix_I2(4,maxngrid_r)
	real*8 submatrix_I3k(4,maxngrid_r),submatrix_I3m(4,maxngrid_r)
	real*8 submatrix_I4(4,maxngrid_r)
	real*8 submatrix_I5k(4,maxngrid_r),submatrix_I5m(4,maxngrid_r)
	real*8 submatrix_I6(4,maxngrid_r)
	real*8 submatrix_I7(4,maxngrid_r)
	real*8 submatrix_I3k_mod(6,maxngrid_r)
	real*8 submatrix_I3m_mod(6,maxngrid_r)
	real*8 submatrix_I4_mod(6,maxngrid_r)
	complex*16 omega
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
c other variables
	real*8 b1,b2,lsq2
	complex*16 D1,D2_p,D2_m,D3_p,D3_m,unelastic_factor
	complex*16 factors_qkappa,factors_qmu
c constant
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
	if ( l.ne.0 ) call error_handling(52)
c **********************************************************************
c Initialing the whole_vector
c **********************************************************************
	call init_complex_array( 10*maxngrid_r,whole_vector_sph )
	call init_complex_array(  5*maxngrid_r,whole_vector_tor )
c **********************************************************************
c Computing the excitation vector
c **********************************************************************
	b1 = dsqrt( dble(2*l+1) / ( 16.d0 * pi ) )
c	b2 = dsqrt( dble(2*l+1)*dble(l-1)*dble(l+2) / ( 64.d0 * pi ) )
	b2 = 0.d0
c --- excitations due to the traction diccontinuities
	factors_qkappa = unelastic_factor( dble(omega), grid_qkappas )
	factors_qmu = unelastic_factor( dble(omega), grid_qmus )
	lsq2 = dble(l) * dble(l+1)
	whole_vector_sph(idim_rs_sph,0)
     &	  = whole_vector_sph(idim_rs_sph,0)
     &	    - b1 * 2.d0
     &	      * ( source_mt(2,2) + source_mt(3,3)
     &	          - 2.d0 * source_mt(1,1)
     &	            * ( grid_Fks * factors_qkappa
     &	                + grid_Fms * factors_qmu
     &	              )
     &	            / ( grid_Cks * factors_qkappa
     &	                + grid_Cms * factors_qmu
     &	              )
     &	          ) / source_r
c --- excitations due to the displacement discontinuities
	D1 = b1 * 2.d0 * source_mt(1,1)
     &	     / ( source_r * source_r
     &	         * ( grid_Cks * factors_qkappa
     &	             + grid_Cms * factors_qmu ) )
	D2_p = dcmplx( 0.d0 )
	D2_m = dcmplx( 0.d0 )
	D3_p = dcmplx( 0.d0 )
	D3_m = dcmplx( 0.d0 )
c ---- spheroidal, m=0
	whole_vector_sph(idim_rs_sph,0)
     &	  = whole_vector_sph(idim_rs_sph,0)
     &	      + ( - omega * omega * submatrix_I0(1,igrid_rs)
     &	          + ( submatrix_I1k(1,igrid_rs)
     &	              + 4.d0 * submatrix_I3k(1,igrid_rs)
     &	              + 4.d0 * submatrix_I5k(1,igrid_rs)
     &	            ) * factors_qkappa
     &	          + ( submatrix_I1m(1,igrid_rs)
     &	              + 4.d0 * submatrix_I3m(1,igrid_rs)
     &	              + 4.d0 * submatrix_I5m(1,igrid_rs)
     &	              + lsq2 * submatrix_I6(1,igrid_rs)
     &	              - 4.d0 * submatrix_I7(1,igrid_rs)
     &	            ) * factors_qmu
     &	        ) * D1
	whole_vector_sph(idim_rs_sph+1,0)
     &	  = whole_vector_sph(idim_rs_sph+1,0)
     &	      + ( - omega * omega * submatrix_I0(3,igrid_rs)
     &	          + ( submatrix_I1k(3,igrid_rs)
     &	              + 2.d0 * submatrix_I3k(2,igrid_rs)
     &	              + 2.d0 * submatrix_I3k(3,igrid_rs)
     &	              + 4.d0 * submatrix_I5k(3,igrid_rs)
     &	            ) * factors_qkappa
     &	          + ( submatrix_I1m(3,igrid_rs)
     &	              + 2.d0 * submatrix_I3m(2,igrid_rs)
     &	              + 2.d0 * submatrix_I3m(3,igrid_rs)
     &	              + 4.d0 * submatrix_I5m(3,igrid_rs)
     &	              + lsq2 * submatrix_I6(3,igrid_rs)
     &	              - 4.d0 * submatrix_I7(3,igrid_rs)
     &	            ) * factors_qmu
     &	        ) * D1
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_wavefield
     &	  ( maxngrid_r,omega,
     &	    submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	    submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	    submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	    submatrix_I6,submatrix_I7,
     &	    submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	    ngrid_r,grid_r,grid_mu,grid_qkappa,grid_qmu,l,
     &	    idim1_sph0,idim2_sph,idim1_tor0,idim2_tor,
     &	    idim0,init_npos_sph,init_npos_tor,
     &	    idim_rs_sph,idim_rs_tor,
     &	    idim_station_sph,idim_station_tor,
     &	    whole_matrix_sph,whole_matrix_tor,
     &	    whole_matrix_dr_sph,whole_matrix_dr_tor,
     &	    whole_vector_sph,whole_vector_tor,work_vector )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing wavefield for the given frequency.
c    required subroutines: init_complex_array
c    required functions: unelastic_factor
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,ngrid_r,l
	integer idim1_sph0,idim2_sph,idim1_tor0,idim2_tor
	integer idim0,init_npos_sph,init_npos_tor
	integer idim_rs_sph,idim_rs_tor
	integer idim_station_sph,idim_station_tor
	real*8 submatrix_I0(4,maxngrid_r)
	real*8 submatrix_I1k(4,maxngrid_r),submatrix_I1m(4,maxngrid_r)
	real*8 submatrix_I2(4,maxngrid_r)
	real*8 submatrix_I3k(4,maxngrid_r),submatrix_I3m(4,maxngrid_r)
	real*8 submatrix_I4(4,maxngrid_r)
	real*8 submatrix_I5k(4,maxngrid_r),submatrix_I5m(4,maxngrid_r)
	real*8 submatrix_I6(4,maxngrid_r)
	real*8 submatrix_I7(4,maxngrid_r)
	real*8 submatrix_I3k_mod(6,maxngrid_r)
	real*8 submatrix_I3m_mod(6,maxngrid_r)
	real*8 submatrix_I4_mod(6,maxngrid_r)
	real*8 grid_r(*),grid_mu(2,*)
	real*8 grid_qkappa(*),grid_qmu(*)
	complex*16 omega
	complex*16 whole_matrix_sph(4,*),whole_matrix_tor(2,*)
	complex*16 whole_matrix_dr_sph(*),whole_matrix_dr_tor(*)
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
	complex*16 work_vector(*)
c other variables
	integer idim1_sph,idim1_tor,ir,npos,m,itype_medium
c itype_medium=1: solid, itype_medium=0: liquid
	integer ndim_whole_matrix_sph,ndim_whole_matrix_tor,ier
	integer init_grid,end_grid,ns,nq
	real*8 lsq,lsq2,eps
	complex*16 unelastic_factor,factor_qkappa(2),factor_qmu(2)
	data eps / -1.d0 /
c
	if ( l.le.0 ) call error_handling(53)
c **********************************************************************
c Initialing the whole_matrix
c **********************************************************************
	call init_complex_array( 8*maxngrid_r,whole_matrix_sph )
	call init_complex_array( 2*maxngrid_r,whole_matrix_tor )
	call init_complex_array( 2*maxngrid_r,whole_matrix_dr_sph )
	call init_complex_array(   maxngrid_r,whole_matrix_dr_tor )
	idim1_sph = max0( idim0,idim1_sph0 )
	idim1_tor = max0( idim0,idim1_tor0 )
c **********************************************************************
c **********************************************************************
c Spheroidal Component
c **********************************************************************
c **********************************************************************
c **********************************************************************
c constructing the whole_matrix
c **********************************************************************
	lsq2 = dble(l) * dble(l+1)
	lsq  = dsqrt( lsq2 )
c
	factor_qkappa(2)
     &	  = unelastic_factor( dble(omega),grid_qkappa(idim1_sph) )
	factor_qmu(2)
     &	  = unelastic_factor( dble(omega),grid_qmu(idim1_sph) )
	if ( grid_mu(1,idim1_sph)*grid_mu(2,idim1_sph).eq.0.d0 ) then
	  npos = init_npos_sph
	  itype_medium = 0
	  whole_matrix_sph(4,npos)
     &	  = omega * omega / factor_qkappa(2)
     &	      * dcmplx( submatrix_I0(1,idim1_sph)
     &	              )
     &	      - dcmplx( lsq2 * submatrix_I1k(1,idim1_sph)
     &	                  + submatrix_I2(1,idim1_sph)
     &	              )
	else
	  npos = init_npos_sph
	  itype_medium = 1
	  whole_matrix_sph(4,npos)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(1,idim1_sph)
     &	              )
     &	      - factor_qkappa(2)
     &	        * dcmplx( submatrix_I1k(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I3k(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I5k(1,idim1_sph)
     &	                )
     &	      - factor_qmu(2)
     &	        * dcmplx( submatrix_I1m(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I3m(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I5m(1,idim1_sph)
     &	                  + lsq2 * submatrix_I6(1,idim1_sph)
     &	                  - 4.d0 * submatrix_I7(1,idim1_sph)
     &	                )
	  whole_matrix_sph(3,npos+1)
     &	  = dcmplx( lsq )
     &	      * (
     &	        factor_qkappa(2)
     &	        * dcmplx( submatrix_I3k_mod(1,idim1_sph)
     &	                  + 2.d0 * submatrix_I5k(1,idim1_sph)
     &	                )
     &	      + factor_qmu(2)
     &	        * dcmplx( submatrix_I3m_mod(1,idim1_sph)
     &	                  - submatrix_I4_mod(1,idim1_sph)
     &	                  + 2.d0 * submatrix_I5m(1,idim1_sph)
     &	                  + submatrix_I6(1,idim1_sph)
     &	                  - 2.d0 * submatrix_I7(1,idim1_sph)
     &	                )
     &	       )
	  whole_matrix_sph(4,npos+1)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(1,idim1_sph)
     &	              )
     &	      - factor_qkappa(2)
     &	        * dcmplx( lsq2 * submatrix_I5k(1,idim1_sph)
     &	                )
     &	      - factor_qmu(2)
     &	        * dcmplx( submatrix_I2(1,idim1_sph)
     &	                  - 2.d0 * submatrix_I4(1,idim1_sph)
     &	                  + lsq2 * submatrix_I5m(1,idim1_sph)
     &	                  + submatrix_I6(1,idim1_sph)
     &	                  - 2.d0 * submatrix_I7(1,idim1_sph)
     &	                )
	endif
	do 120 ir=idim1_sph+1,idim2_sph-1
	  factor_qkappa(1)
     &	    = unelastic_factor( dble(omega),grid_qkappa(ir-1) )
	  factor_qmu(1)
     &	    = unelastic_factor( dble(omega),grid_qmu(ir-1) )
	  factor_qkappa(2)
     &	    = unelastic_factor( dble(omega),grid_qkappa(ir) )
	  factor_qmu(2)
     &	    = unelastic_factor( dble(omega),grid_qmu(ir) )
	  if ( grid_mu(1,ir)*grid_mu(2,ir).eq.0.d0 ) then
	    if ( itype_medium.eq.1 ) then
	      npos = npos + 2
	      whole_matrix_sph(2,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(2,ir-1)
     &	                )
     &	        - factor_qkappa(1)
     &	          * dcmplx( submatrix_I1k(2,ir-1)
     &	                + 2.d0 * submatrix_I3k(2,ir-1)
     &	                + 2.d0 * submatrix_I3k(3,ir-1)
     &	                + 4.d0 * submatrix_I5k(2,ir-1)
     &	                  )
     &	        - factor_qmu(1)
     &	          * dcmplx( submatrix_I1m(2,ir-1)
     &	                + 2.d0 * submatrix_I3m(2,ir-1)
     &	                + 2.d0 * submatrix_I3m(3,ir-1)
     &	                + 4.d0 * submatrix_I5m(2,ir-1)
     &	                + lsq2 * submatrix_I6(2,ir-1)
     &	                - 4.d0 * submatrix_I7(2,ir-1)
     &	              )
	      whole_matrix_sph(3,npos)
     &	      = whole_matrix_sph(3,npos)
     &	        + dcmplx( lsq )
     &	        * (
     &	        factor_qkappa(1)
     &	        * dcmplx( submatrix_I3k_mod(2,ir-1)
     &	                  + submatrix_I3k_mod(5,ir-1)
     &	                  + 2.d0 * submatrix_I5k(2,ir-1)
     &	                )
     &	        + factor_qmu(1)
     &	          * dcmplx( submatrix_I3m_mod(2,ir-1)
     &	                    + submatrix_I3m_mod(5,ir-1)
     &	                    - submatrix_I4_mod(2,ir-1)
     &	                    - submatrix_I4_mod(5,ir-1)
     &	                    + 2.d0 * submatrix_I5m(2,ir-1)
     &	                    + submatrix_I6(2,ir-1)
     &	                    - 2.d0 * submatrix_I7(2,ir-1)
     &	                  )
     &	         )
	      whole_matrix_sph(4,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                )
     &	        - factor_qkappa(1)
     &	          * dcmplx( submatrix_I1k(4,ir-1)
     &	                    + 4.d0 * submatrix_I3k(4,ir-1)
     &	                    + 4.d0 * submatrix_I5k(4,ir-1)
     &	                  )
     &	        - factor_qmu(1)
     &	          * dcmplx( submatrix_I1m(4,ir-1)
     &	                    + 4.d0 * submatrix_I3m(4,ir-1)
     &	                    + 4.d0 * submatrix_I5m(4,ir-1)
     &	                    + lsq2 * submatrix_I6(4,ir-1)
     &	                    - 4.d0 * submatrix_I7(4,ir-1)
     &	                   )
	      whole_matrix_sph(1,npos+1)
     &	      = dcmplx( lsq )
     &	        * (
     &	          factor_qkappa(1)
     &	          * dcmplx( submatrix_I3k_mod(3,ir-1)
     &	                    + 2.d0 * submatrix_I5k(2,ir-1)
     &	                  )
     &	          + factor_qmu(1)
     &	            * dcmplx( submatrix_I3m_mod(3,ir-1)
     &	                      - submatrix_I4_mod(3,ir-1)
     &	                      + 2.d0 * submatrix_I5m(2,ir-1)
     &	                      + submatrix_I6(2,ir-1)
     &	                      - 2.d0 * submatrix_I7(2,ir-1)
     &	                    )
     &	           )
	      whole_matrix_sph(2,npos+1)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(2,ir-1)
     &	                )
     &	        - factor_qkappa(1)
     &	          * dcmplx( lsq2 * submatrix_I5k(2,ir-1)
     &	                  )
     &	        - factor_qmu(1)
     &	          * dcmplx( submatrix_I2(2,ir-1)
     &	                    - submatrix_I4(2,ir-1)
     &	                    - submatrix_I4(3,ir-1)
     &	                    + lsq2 * submatrix_I5m(2,ir-1)
     &	                    + submatrix_I6(2,ir-1)
     &	                    - 2.d0 * submatrix_I7(2,ir-1)
     &	                  )
	      whole_matrix_sph(3,npos+1)
     &	      = dcmplx( lsq )
     &	        * (
     &	          factor_qkappa(1)
     &	          * dcmplx( submatrix_I3k_mod(4,ir-1)
     &	                    + submatrix_I3k_mod(6,ir-1)
     &	                    + 2.d0 * submatrix_I5k(4,ir-1)
     &	                  )
     &	          + factor_qmu(1)
     &	            * dcmplx( submatrix_I3m_mod(4,ir-1)
     &	                      + submatrix_I3m_mod(6,ir-1)
     &	                      - submatrix_I4_mod(4,ir-1)
     &	                      - submatrix_I4_mod(6,ir-1)
     &	                      + 2.d0 * submatrix_I5m(4,ir-1)
     &	                      + submatrix_I6(4,ir-1)
     &	                      - 2.d0 * submatrix_I7(4,ir-1)
     &	                    )
     &	          )
	      whole_matrix_sph(4,npos+1)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                )
     &	          - factor_qkappa(1)
     &	            * dcmplx( lsq2 * submatrix_I5k(4,ir-1)
     &	                    )
     &	          - factor_qmu(1)
     &	            * dcmplx( submatrix_I2(4,ir-1)
     &	                      - 2.d0 * submatrix_I4(4,ir-1)
     &	                      + lsq2 * submatrix_I5m(4,ir-1)
     &	                      + submatrix_I6(4,ir-1)
     &	                      - 2.d0 * submatrix_I7(4,ir-1)
     &	                    )
	      npos = npos + 2
	      itype_medium = 0
	      whole_matrix_sph(2,npos)
     &	      = omega * grid_r(ir) * grid_r(ir)
	      whole_matrix_sph(4,npos)
     &	        = omega * omega / factor_qkappa(2)
     &	        * dcmplx( submatrix_I0(1,ir)
     &	                )
     &	        - dcmplx( lsq2 * submatrix_I1k(1,ir)
     &	                  + submatrix_I2(1,ir)
     &	                )
	    else
	      npos = npos + 1
	      itype_medium = 0
	      whole_matrix_sph(3,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(2,ir-1) ) / factor_qkappa(1)
     &	        - dcmplx( lsq2 * submatrix_I1k(2,ir-1)
     &	                  + submatrix_I2(2,ir-1)
     &	                )
	      whole_matrix_sph(4,npos)
     &	        = omega * omega
     &	        * ( dcmplx( submatrix_I0(4,ir-1) ) / factor_qkappa(1)
     &	            + dcmplx( submatrix_I0(1,ir) ) / factor_qkappa(2)
     &	          )
     &	        - dcmplx( lsq2 * submatrix_I1k(4,ir-1)
     &	                  + submatrix_I2(4,ir-1)
     &	                )
     &	        - dcmplx( lsq2 * submatrix_I1k(1,ir)
     &	                  + submatrix_I2(1,ir)
     &	                )
	    endif
	  else
	    if ( itype_medium.eq.0 ) then
	      npos = npos + 1
	      whole_matrix_sph(3,npos)
     &	      = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(2,ir-1) )
     &	        - dcmplx( lsq2 * submatrix_I1k(2,ir-1)
     &	                  + submatrix_I2(2,ir-1)
     &	                )
	      whole_matrix_sph(4,npos)
     &	      = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                )
     &	        - dcmplx( lsq2 * submatrix_I1k(4,ir-1)
     &	                  + submatrix_I2(4,ir-1)
     &	                )
	      npos = npos + 1
	      itype_medium = 1
	      whole_matrix_sph(3,npos)
     &	      = - omega * grid_r(ir) * grid_r(ir)
	      whole_matrix_sph(4,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(1,ir)
     &	                )
     &	        - factor_qkappa(2)
     &	        * dcmplx( submatrix_I1k(1,ir)
     &	                  + 4.d0 * submatrix_I3k(1,ir)
     &	                  + 4.d0 * submatrix_I5k(1,ir)
     &	                )
     &	        - factor_qmu(2)
     &	        * dcmplx( submatrix_I1m(1,ir)
     &	                  + 4.d0 * submatrix_I3m(1,ir)
     &	                  + 4.d0 * submatrix_I5m(1,ir)
     &	                  + lsq2 * submatrix_I6(1,ir)
     &	                  - 4.d0 * submatrix_I7(1,ir)
     &	                )
	      whole_matrix_sph(3,npos+1)
     &	      = dcmplx( lsq )
     &	      * (
     &	          factor_qkappa(2)
     &	        * dcmplx( submatrix_I3k_mod(1,ir)
     &	                  + 2.d0 * submatrix_I5k(1,ir)
     &	                )
     &	        + factor_qmu(2)
     &	        * dcmplx( submatrix_I3m_mod(1,ir)
     &	                  - submatrix_I4_mod(1,ir)
     &	                  + 2.d0 * submatrix_I5m(1,ir)
     &	                  + submatrix_I6(1,ir)
     &	                  - 2.d0 * submatrix_I7(1,ir)
     &	                )
     &	       )
	      whole_matrix_sph(4,npos+1)
     &	      = omega * omega
     &	      * dcmplx( submatrix_I0(1,ir)
     &	              )
     &	      - factor_qkappa(2)
     &	        * dcmplx( lsq2 * submatrix_I5k(1,ir)
     &	                )
     &	      - factor_qmu(2)
     &	        * dcmplx( submatrix_I2(1,ir)
     &	                  - 2.d0 * submatrix_I4(1,ir)
     &	                  + lsq2 * submatrix_I5m(1,ir)
     &	                  + submatrix_I6(1,ir)
     &	                  - 2.d0 * submatrix_I7(1,ir)
     &	                )
	    else
	      npos = npos + 2
	      itype_medium = 1
	      whole_matrix_sph(2,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(2,ir-1)
     &	                )
     &	        - factor_qkappa(1)
     &	        * dcmplx( submatrix_I1k(2,ir-1)
     &	                  + 2.d0 * submatrix_I3k(2,ir-1)
     &	                  + 2.d0 * submatrix_I3k(3,ir-1)
     &	                  + 4.d0 * submatrix_I5k(2,ir-1)
     &	                )
     &	        - factor_qmu(1)
     &	        * dcmplx( submatrix_I1m(2,ir-1)
     &	                  + 2.d0 * submatrix_I3m(2,ir-1)
     &	                  + 2.d0 * submatrix_I3m(3,ir-1)
     &	                  + 4.d0 * submatrix_I5m(2,ir-1)
     &	                  + lsq2 * submatrix_I6(2,ir-1)
     &	                  - 4.d0 * submatrix_I7(2,ir-1)
     &	                )
	      whole_matrix_sph(3,npos)
     &	      = whole_matrix_sph(3,npos)
     &	      + dcmplx( lsq )
     &	      * (
     &	        factor_qkappa(1)
     &	        * dcmplx( submatrix_I3k_mod(2,ir-1)
     &	                  + 2.d0 * submatrix_I5k(2,ir-1)
     &	                )
     &	        + factor_qmu(1)
     &	        * dcmplx( submatrix_I3m_mod(2,ir-1)
     &	                  - submatrix_I4_mod(2,ir-1)
     &	                  + 2.d0 * submatrix_I5m(2,ir-1)
     &	                  + submatrix_I6(2,ir-1)
     &	                  - 2.d0 * submatrix_I7(2,ir-1)
     &	                )
     &	       )
	      whole_matrix_sph(4,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                  + submatrix_I0(1,ir)
     &	                )
     &	        - factor_qkappa(1)
     &	        * dcmplx( submatrix_I1k(4,ir-1)
     &	                  + 4.d0 * submatrix_I3k(4,ir-1)
     &	                  + 4.d0 * submatrix_I5k(4,ir-1)
     &	                )
     &	        - factor_qmu(1)
     &	        * dcmplx( submatrix_I1m(4,ir-1)
     &	                  + 4.d0 * submatrix_I3m(4,ir-1)
     &	                  + 4.d0 * submatrix_I5m(4,ir-1)
     &	                  + lsq2 * submatrix_I6(4,ir-1)
     &	                  - 4.d0 * submatrix_I7(4,ir-1)
     &	                )
     &	        - factor_qkappa(2)
     &	        * dcmplx( submatrix_I1k(1,ir)
     &	                  + 4.d0 * submatrix_I3k(1,ir)
     &	                  + 4.d0 * submatrix_I5k(1,ir)
     &	                )
     &	        - factor_qmu(2)
     &	        * dcmplx( submatrix_I1m(1,ir)
     &	                  + 4.d0 * submatrix_I3m(1,ir)
     &	                  + 4.d0 * submatrix_I5m(1,ir)
     &	                  + lsq2 * submatrix_I6(1,ir)
     &	                  - 4.d0 * submatrix_I7(1,ir)
     &	                )
	      whole_matrix_sph(1,npos+1)
     &	      = dcmplx( lsq )
     &	      * (
     &	        factor_qkappa(1)
     &	        * dcmplx( submatrix_I3k_mod(3,ir-1)
     &	                  + 2.d0 * submatrix_I5k(2,ir-1)
     &	                )
     &	        + factor_qmu(1)
     &	        * dcmplx( submatrix_I3m_mod(3,ir-1)
     &	                  - submatrix_I4_mod(3,ir-1)
     &	                  + 2.d0 * submatrix_I5m(2,ir-1)
     &	                  + submatrix_I6(2,ir-1)
     &	                  - 2.d0 * submatrix_I7(2,ir-1)
     &	                )
     &	         )
	      whole_matrix_sph(2,npos+1)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(2,ir-1)
     &	              )
     &	        - factor_qkappa(1)
     &	        * dcmplx( lsq2 * submatrix_I5k(2,ir-1)
     &	                )
     &	        - factor_qmu(1)
     &	        * dcmplx( submatrix_I2(2,ir-1)
     &	                  - submatrix_I4(2,ir-1)
     &	                  - submatrix_I4(3,ir-1)
     &	                  + lsq2 * submatrix_I5m(2,ir-1)
     &	                  + submatrix_I6(2,ir-1)
     &	                  - 2.d0 * submatrix_I7(2,ir-1)
     &	                )
	      whole_matrix_sph(3,npos+1)
     &	      = dcmplx( lsq )
     &	        * (
     &	        factor_qkappa(1)
     &	        * dcmplx( submatrix_I3k_mod(4,ir-1)
     &	                  + 2.d0 * submatrix_I5k(4,ir-1)
     &	                )
     &	        + factor_qmu(1)
     &	        * dcmplx( submatrix_I3m_mod(4,ir-1)
     &	                  - submatrix_I4_mod(4,ir-1)
     &	                  + 2.d0 * submatrix_I5m(4,ir-1)
     &	                  + submatrix_I6(4,ir-1)
     &	                  - 2.d0 * submatrix_I7(4,ir-1)
     &	                )
     &	        + factor_qkappa(2)
     &	        * dcmplx( submatrix_I3k_mod(1,ir)
     &	                  + 2.d0 * submatrix_I5k(1,ir)
     &	                )
     &	        + factor_qmu(2)
     &	        * dcmplx( submatrix_I3m_mod(1,ir)
     &	                  - submatrix_I4_mod(1,ir)
     &	                  + 2.d0 * submatrix_I5m(1,ir)
     &	                  + submatrix_I6(1,ir)
     &	                  - 2.d0 * submatrix_I7(1,ir)
     &	                )
     &	         )
	      whole_matrix_sph(4,npos+1)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                + submatrix_I0(1,ir)
     &	              )
     &	        - factor_qkappa(1)
     &	        * dcmplx( lsq2 * submatrix_I5k(4,ir-1)
     &	                )
     &	        - factor_qmu(1)
     &	        * dcmplx( submatrix_I2(4,ir-1)
     &	                  - 2.d0 * submatrix_I4(4,ir-1)
     &	                  + lsq2 * submatrix_I5m(4,ir-1)
     &	                  + submatrix_I6(4,ir-1)
     &	                  - 2.d0 * submatrix_I7(4,ir-1)
     &	                )
     &	        - factor_qkappa(2)
     &	        * dcmplx( lsq2 * submatrix_I5k(1,ir)
     &	                )
     &	        - factor_qmu(2)
     &	        * dcmplx( submatrix_I2(1,ir)
     &	                  - 2.d0 * submatrix_I4(1,ir)
     &	                  + lsq2 * submatrix_I5m(1,ir)
     &	                  + submatrix_I6(1,ir)
     &	                  - 2.d0 * submatrix_I7(1,ir)
     &	                )
	      whole_matrix_sph(1,npos+2)
     &	      = dcmplx( lsq )
     &	      * (
     &	        factor_qkappa(1)
     &	        * dcmplx( submatrix_I3k_mod(5,ir-1)
     &	                )
     &	        + factor_qmu(1)
     &	        * dcmplx( submatrix_I3m_mod(5,ir-1)
     &	                  - submatrix_I4_mod(5,ir-1)
     &	                )
     &	       )
	      whole_matrix_sph(3,npos+2)
     &	      = dcmplx( lsq )
     &	      * (
     &	        factor_qkappa(1)
     &	        * dcmplx( submatrix_I3k_mod(6,ir-1)
     &	                )
     &	        + factor_qmu(1)
     &	        * dcmplx( submatrix_I3m_mod(6,ir-1)
     &	                  - submatrix_I4_mod(6,ir-1)
     &	                )
     &	       )
	    endif
	  endif
  120	continue
	factor_qkappa(1)
     &	  = unelastic_factor( dble(omega),grid_qkappa(idim2_sph-1) )
	factor_qmu(1)
     &	  = unelastic_factor( dble(omega),grid_qmu(idim2_sph-1) )
	if ( itype_medium.eq.0 ) then
	  npos = npos + 1
	  whole_matrix_sph(3,npos)
     &	    = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(2,idim2_sph-1)
     &	                )
     &	      - dcmplx( lsq2 * submatrix_I1k(2,idim2_sph-1)
     &	                  + submatrix_I2(2,idim2_sph-1)
     &	              )
	    whole_matrix_sph(4,npos)
     &	      = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(4,idim2_sph-1)
     &	                )
     &	      - dcmplx( lsq2 * submatrix_I1k(4,idim2_sph-1)
     &	                  + submatrix_I2(4,idim2_sph-1)
     &	                )
	  ndim_whole_matrix_sph = npos
	else
	  npos = npos + 2
	  whole_matrix_sph(2,npos)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(2,idim2_sph-1)
     &	              )
     &	    - factor_qkappa(1)
     &	      * dcmplx( submatrix_I1k(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3k(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3k(3,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5k(2,idim2_sph-1)
     &	              )
     &	    - factor_qmu(1)
     &	      * dcmplx( submatrix_I1m(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3m(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3m(3,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5m(2,idim2_sph-1)
     &	                + lsq2 * submatrix_I6(2,idim2_sph-1)
     &	                - 4.d0 * submatrix_I7(2,idim2_sph-1)
     &	              )
	  whole_matrix_sph(3,npos)
     &	  = whole_matrix_sph(3,npos)
     &	    + dcmplx( lsq )
     &	    * (
     &	      factor_qkappa(1)
     &	      * dcmplx( submatrix_I3k_mod(2,idim2_sph-1)
     &	                + submatrix_I3k_mod(5,idim2_sph-1)
     &	                + 2.d0 * submatrix_I5k(2,idim2_sph-1)
     &	              )
     &	    + factor_qmu(1)
     &	      * dcmplx( submatrix_I3m_mod(2,idim2_sph-1)
     &	                + submatrix_I3m_mod(5,idim2_sph-1)
     &	                - submatrix_I4_mod(2,idim2_sph-1)
     &	                - submatrix_I4_mod(5,idim2_sph-1)
     &	                + 2.d0 * submatrix_I5m(2,idim2_sph-1)
     &	                + submatrix_I6(2,idim2_sph-1)
     &	                - 2.d0 * submatrix_I7(2,idim2_sph-1)
     &	              )
     &	     )
	  whole_matrix_sph(4,npos)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(4,idim2_sph-1)
     &	              )
     &	    - factor_qkappa(1)
     &	      * dcmplx( submatrix_I1k(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I3k(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5k(4,idim2_sph-1)
     &	              )
     &	    - factor_qmu(1)
     &	      * dcmplx( submatrix_I1m(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I3m(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5m(4,idim2_sph-1)
     &	                + lsq2 * submatrix_I6(4,idim2_sph-1)
     &	                - 4.d0 * submatrix_I7(4,idim2_sph-1)
     &	              )
	  whole_matrix_sph(1,npos+1)
     &	  = dcmplx( lsq )
     &	    * (
     &	      factor_qkappa(1)
     &	      * dcmplx( submatrix_I3k_mod(3,idim2_sph-1)
     &	                + 2.d0 * submatrix_I5k(2,idim2_sph-1)
     &	              )
     &	    + factor_qmu(1)
     &	      * dcmplx( submatrix_I3m_mod(3,idim2_sph-1)
     &	                - submatrix_I4_mod(3,idim2_sph-1)
     &	                + 2.d0 * submatrix_I5m(2,idim2_sph-1)
     &	                + submatrix_I6(2,idim2_sph-1)
     &	                - 2.d0 * submatrix_I7(2,idim2_sph-1)
     &	              )
     &	     )
	  whole_matrix_sph(2,npos+1)
     &	  = omega * omega
     &	    * dcmplx( submatrix_I0(2,idim2_sph-1)
     &	            )
     &	    - factor_qkappa(1)
     &	      * dcmplx( lsq2 * submatrix_I5k(2,idim2_sph-1)
     &	              )
     &	    - factor_qmu(1)
     &	      * dcmplx( submatrix_I2(2,idim2_sph-1)
     &	                - submatrix_I4(2,idim2_sph-1)
     &	                - submatrix_I4(3,idim2_sph-1)
     &	                + lsq2 * submatrix_I5m(2,idim2_sph-1)
     &	                + submatrix_I6(2,idim2_sph-1)
     &	                - 2.d0 * submatrix_I7(2,idim2_sph-1)
     &	              )
	  whole_matrix_sph(3,npos+1)
     &	  = dcmplx( lsq )
     &	    * (
     &	      factor_qkappa(1)
     &	      * dcmplx( submatrix_I3k_mod(4,idim2_sph-1)
     &	                + submatrix_I3k_mod(6,idim2_sph-1)
     &	                + 2.d0 * submatrix_I5k(4,idim2_sph-1)
     &	              )
     &	    + factor_qmu(1)
     &	      * dcmplx( submatrix_I3m_mod(4,idim2_sph-1)
     &	                + submatrix_I3m_mod(6,idim2_sph-1)
     &	                - submatrix_I4_mod(4,idim2_sph-1)
     &	                - submatrix_I4_mod(6,idim2_sph-1)
     &	                + 2.d0 * submatrix_I5m(4,idim2_sph-1)
     &	                + submatrix_I6(4,idim2_sph-1)
     &	                - 2.d0 * submatrix_I7(4,idim2_sph-1)
     &	              )
     &	     )
	  whole_matrix_sph(4,npos+1)
     &	  = omega * omega
     &	    * dcmplx( submatrix_I0(4,idim2_sph-1)
     &	            )
     &	    - factor_qkappa(1)
     &	      * dcmplx( lsq2 * submatrix_I5k(4,idim2_sph-1)
     &	              )
     &	    - factor_qmu(1)
     &	      * dcmplx( submatrix_I2(4,idim2_sph-1)
     &	                - 2.d0 * submatrix_I4(4,idim2_sph-1)
     &	                + lsq2 * submatrix_I5m(4,idim2_sph-1)
     &	                + submatrix_I6(4,idim2_sph-1)
     &	                - 2.d0 * submatrix_I7(4,idim2_sph-1)
     &	              )
	  ndim_whole_matrix_sph = npos+1
	endif
c **********************************************************************
c computing the wavefield
c **********************************************************************
c imposing fixed boundary conditions at r=0 and free surface boundary
c conditions at the surface
	if ( ( grid_mu(1,idim1_sph)*grid_mu(2,idim1_sph).ne.0.d0 )
     &	     .and.( grid_r(idim1_sph).eq.0.d0 ) ) then
	  init_grid = max0(init_npos_sph,3)
	else
	  init_grid = init_npos_sph
	endif
	if ( grid_mu(1,idim2_sph-1)*grid_mu(2,idim2_sph-1).eq.0.d0 )
     &	  then
	  end_grid = ndim_whole_matrix_sph - 1
	else
	  end_grid = ndim_whole_matrix_sph
	endif
	m = max0(-l,-2)
	ns = idim_rs_sph - init_grid + 1
	if ( mod(l,100).eq.0 ) then
	  nq = end_grid - init_grid + 1
	else
	  nq = min0( end_grid - idim_station_sph + 1,
     &	             end_grid - init_grid + 1 )
	endif
	call dclisb(whole_matrix_sph(1,init_grid),
     &	            end_grid - init_grid + 1,
     &	            3,4,ns,nq,whole_vector_sph(init_grid,m),
     &	            eps,whole_matrix_dr_sph(init_grid),
     &	            work_vector(init_grid),ier)
	do 200 m=max0(-l,-2)+1,min0(l,2)
	  call dcsbsub(whole_matrix_sph(1,init_grid),
     &	               end_grid - init_grid + 1,
     &	               3,4,ns,nq,whole_vector_sph(init_grid,m),
     &	               eps,whole_matrix_dr_sph(init_grid),
     &	               work_vector(init_grid),ier)
  200	continue
c
c **********************************************************************
c **********************************************************************
c Toroidal Component
c **********************************************************************
c **********************************************************************
c **********************************************************************
c constructing the whole_matrix
c **********************************************************************
	factor_qmu(2)
     &	  = unelastic_factor( dble(omega),grid_qmu(idim1_tor) )
	npos = init_npos_tor
	whole_matrix_tor(2,npos)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(1,idim1_tor)
     &	              )
     &	      - factor_qmu(2)
     &	        * dcmplx( submatrix_I2(1,idim1_tor)
     &	                  - 2.d0 * submatrix_I4(1,idim1_tor)
     &	                  + submatrix_I6(1,idim1_tor)
     &	                  + ( lsq2 - 2.d0 ) * submatrix_I7(1,idim1_tor)
     &	                )
	do 320 ir=idim1_tor+1,idim2_tor-1
	  factor_qmu(1)
     &	    = unelastic_factor( dble(omega),grid_qmu(ir-1) )
	  factor_qmu(2)
     &	    = unelastic_factor( dble(omega),grid_qmu(ir) )
	  npos = npos + 1
	  whole_matrix_tor(1,npos)
     &	    = omega * omega
     &	        * dcmplx(  submatrix_I0(2,ir-1)
     &	                )
     &	        - factor_qmu(1)
     &	          * dcmplx( submatrix_I2(2,ir-1)
     &	                      - submatrix_I4(2,ir-1)
     &	                      - submatrix_I4(3,ir-1)
     &	                      + submatrix_I6(2,ir-1)
     &	                      + ( lsq2 - 2.d0 )
     &	                        * submatrix_I7(2,ir-1)
     &	                  )
	  whole_matrix_tor(2,npos)
     &	    = omega * omega
     &	        * dcmplx(   submatrix_I0(4,ir-1)
     &	                  + submatrix_I0(1,ir)
     &	                )
     &	        - factor_qmu(1)
     &	          * dcmplx( submatrix_I2(4,ir-1)
     &	                      - 2.d0 * submatrix_I4(4,ir-1)
     &	                      + submatrix_I6(4,ir-1)
     &	                      + ( lsq2 - 2.d0 )
     &	                        * submatrix_I7(4,ir-1)
     &	                  )
     &	        - factor_qmu(2)
     &	          * dcmplx( submatrix_I2(1,ir)
     &	                      - 2.d0 * submatrix_I4(1,ir)
     &	                      + submatrix_I6(1,ir)
     &	                      + ( lsq2 - 2.d0 )
     &	                        * submatrix_I7(1,ir)
     &	                  )
  320	continue
	factor_qmu(1)
     &	  = unelastic_factor( dble(omega),
     &	                      grid_qmu(idim2_tor-1) )
	npos = npos + 1
	whole_matrix_tor(1,npos)
     &	  = omega * omega
     &	      * dcmplx(   submatrix_I0(2,idim2_tor-1)
     &	              )
     &	      - factor_qmu(1)
     &	        * dcmplx( submatrix_I2(2,idim2_tor-1)
     &	                  - submatrix_I4(2,idim2_tor-1)
     &	                  - submatrix_I4(3,idim2_tor-1)
     &	                  + submatrix_I6(2,idim2_tor-1)
     &	                  + ( lsq2 - 2.d0 )
     &	                    * submatrix_I7(2,idim2_tor-1) )
	whole_matrix_tor(2,npos)
     &	  = omega * omega
     &	      * dcmplx(  submatrix_I0(4,idim2_tor-1)
     &	              )
     &	      - factor_qmu(1)
     &	        * dcmplx( submatrix_I2(4,idim2_tor-1)
     &	                  - 2.d0 * submatrix_I4(4,idim2_tor-1)
     &	                  + submatrix_I6(4,idim2_tor-1)
     &	                  + ( lsq2 - 2.d0 )
     &	                    * submatrix_I7(4,idim2_tor-1) )
	ndim_whole_matrix_tor = npos
c **********************************************************************
c computing the wavefield
c **********************************************************************
	m = max0(-l,-2)
	init_grid = init_npos_tor
	end_grid = ndim_whole_matrix_tor
	ns = idim_rs_tor - init_grid + 1
	if ( mod(l,100).eq.0 ) then
	  nq = end_grid - init_grid + 1
	else
	  nq = min0( end_grid - idim_station_tor + 1,
     &	             end_grid - init_grid + 1 )
	endif
	call dclisb(whole_matrix_tor(1,init_grid),
     &	            end_grid - init_grid + 1,
     &	            1,2,ns,nq,whole_vector_tor(init_grid,m),
     &	            eps,whole_matrix_dr_tor(init_grid),
     &	            work_vector(init_grid),ier)
	do 400 m=max0(-l,-2)+1,min0(l,2)
	  call dcsbsub(whole_matrix_tor(1,init_grid),
     &	               end_grid - init_grid + 1,
     &	               1,2,ns,nq,whole_vector_tor(init_grid,m),
     &	               eps,whole_matrix_dr_tor(init_grid),
     &	               work_vector(init_grid),ier)
  400	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_wavefield0
     &	  ( maxngrid_r,omega,
     &	    submatrix_I0,submatrix_I1k,submatrix_I1m,
     &	    submatrix_I2,submatrix_I3k,submatrix_I3m,
     &	    submatrix_I4,submatrix_I5k,submatrix_I5m,
     &	    submatrix_I6,submatrix_I7,
     &	    submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod,
     &	    ngrid_r,grid_r,grid_mu,grid_qkappa,grid_qmu,l,
     &	    idim1_sph,idim2_sph,idim1_tor,idim2_tor,
     &	    idim0,init_npos_sph,init_npos_tor,
     &	    idim_rs_sph,idim_rs_tor,
     &	    idim_station_sph,idim_station_tor,
     &	    whole_matrix_sph,whole_matrix_tor,
     &	    whole_matrix_dr_sph,whole_matrix_dr_tor,
     &	    whole_vector_sph,whole_vector_tor,work_vector )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing wavefield for the given frequency.
c    required subroutines: init_complex_array,error_handling
c    required functions: unelastic_factor
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,ngrid_r,l
	integer idim1_sph,idim2_sph,idim1_tor,idim2_tor
	integer idim0,init_npos_sph,init_npos_tor
	integer idim_rs_sph,idim_rs_tor
	integer idim_station_sph,idim_station_tor
	real*8 submatrix_I0(4,maxngrid_r)
	real*8 submatrix_I1k(4,maxngrid_r),submatrix_I1m(4,maxngrid_r)
	real*8 submatrix_I2(4,maxngrid_r)
	real*8 submatrix_I3k(4,maxngrid_r),submatrix_I3m(4,maxngrid_r)
	real*8 submatrix_I4(4,maxngrid_r)
	real*8 submatrix_I5k(4,maxngrid_r),submatrix_I5m(4,maxngrid_r)
	real*8 submatrix_I6(4,maxngrid_r)
	real*8 submatrix_I7(4,maxngrid_r)
	real*8 submatrix_I3k_mod(6,maxngrid_r)
	real*8 submatrix_I3m_mod(6,maxngrid_r)
	real*8 submatrix_I4_mod(6,maxngrid_r)
	real*8 grid_r(*),grid_mu(2,*)
	real*8 grid_qkappa(*),grid_qmu(*)
	complex*16 omega
	complex*16 whole_matrix_sph(4,*),whole_matrix_tor(2,*)
	complex*16 whole_matrix_dr_sph(*),whole_matrix_dr_tor(*)
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
	complex*16 work_vector(*)
c other variables
	integer ir,npos,m,itype_medium
c itype_medium=1: solid, itype_medium=0: liquid
	integer ndim_whole_matrix_sph,ndim_whole_matrix_tor,ier
	integer init_grid,end_grid,ns,nq
	real*8 lsq,lsq2,eps
	complex*16 unelastic_factor,factor_qkappa(2),factor_qmu(2)
	data eps / -1.d0 /
c
	if ( l.ne.0 ) call error_handling(54)
c **********************************************************************
c Initialing the whole_matrix
c **********************************************************************
	call init_complex_array( 8*maxngrid_r,whole_matrix_sph )
	call init_complex_array( 2*maxngrid_r,whole_matrix_dr_sph )
	idim0 = 1
	init_npos_sph = 1
	init_npos_tor = 1
c **********************************************************************
c **********************************************************************
c Spheroidal Component
c **********************************************************************
c **********************************************************************
c **********************************************************************
c constructing the whole_matrix
c **********************************************************************
	lsq2 = dble(l) * dble(l+1)
	lsq  = dsqrt( lsq2 )
c
	factor_qkappa(2)
     &	  = unelastic_factor( dble(omega),grid_qkappa(idim1_sph) )
	factor_qmu(2)
     &	  = unelastic_factor( dble(omega),grid_qmu(idim1_sph) )
	if ( grid_mu(1,idim1_sph)*grid_mu(2,idim1_sph).eq.0.d0 ) then
	  npos = 1
	  itype_medium = 0
	  whole_matrix_sph(2,npos)
     &	  = omega * omega / factor_qkappa(2)
     &	      * dcmplx( submatrix_I0(1,idim1_sph)
     &	              )
     &	    - dcmplx( lsq2 * submatrix_I1k(1,idim1_sph)
     &	                  + submatrix_I2(1,idim1_sph)
     &	            )
	else
	  npos = 1
	  itype_medium = 1
	  whole_matrix_sph(2,npos)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(1,idim1_sph)
     &	              )
     &	      - factor_qkappa(2)
     &	        * dcmplx( submatrix_I1k(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I3k(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I5k(1,idim1_sph)
     &	                )
     &	      - factor_qmu(2)
     &	        * dcmplx( submatrix_I1m(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I3m(1,idim1_sph)
     &	                  + 4.d0 * submatrix_I5m(1,idim1_sph)
     &	                  + lsq2 * submatrix_I6(1,idim1_sph)
     &	                  - 4.d0 * submatrix_I7(1,idim1_sph)
     &	                )
	endif
	do 120 ir=idim1_sph+1,idim2_sph-1
	  factor_qkappa(1)
     &	      = unelastic_factor( dble(omega),grid_qkappa(ir-1) )
	  factor_qmu(1)
     &	      = unelastic_factor( dble(omega),grid_qmu(ir-1) )
	  factor_qkappa(2)
     &	    = unelastic_factor( dble(omega),grid_qkappa(ir) )
	  factor_qmu(2)
     &	    = unelastic_factor( dble(omega),grid_qmu(ir) )
	  if ( grid_mu(1,ir)*grid_mu(2,ir).eq.0.d0 ) then
	    if ( itype_medium.eq.1 ) then
	      npos = npos + 1
	      whole_matrix_sph(1,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(2,ir-1)
     &	                )
     &	        - factor_qkappa(1)
     &	          * dcmplx( submatrix_I1k(2,ir-1)
     &	                + 2.d0 * submatrix_I3k(2,ir-1)
     &	                + 2.d0 * submatrix_I3k(3,ir-1)
     &	                + 4.d0 * submatrix_I5k(2,ir-1)
     &	                  )
     &	        - factor_qmu(1)
     &	          * dcmplx( submatrix_I1m(2,ir-1)
     &	                + 2.d0 * submatrix_I3m(2,ir-1)
     &	                + 2.d0 * submatrix_I3m(3,ir-1)
     &	                + 4.d0 * submatrix_I5m(2,ir-1)
     &	                + lsq2 * submatrix_I6(2,ir-1)
     &	                - 4.d0 * submatrix_I7(2,ir-1)
     &	              )
	      whole_matrix_sph(2,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                )
     &	        - factor_qkappa(1)
     &	          * dcmplx( submatrix_I1k(4,ir-1)
     &	                    + 4.d0 * submatrix_I3k(4,ir-1)
     &	                    + 4.d0 * submatrix_I5k(4,ir-1)
     &	                  )
     &	        - factor_qmu(1)
     &	          * dcmplx( submatrix_I1m(4,ir-1)
     &	                    + 4.d0 * submatrix_I3m(4,ir-1)
     &	                    + 4.d0 * submatrix_I5m(4,ir-1)
     &	                    + lsq2 * submatrix_I6(4,ir-1)
     &	                    - 4.d0 * submatrix_I7(4,ir-1)
     &	                   )
	      npos = npos + 1
	      itype_medium = 0
	      whole_matrix_sph(1,npos)
     &	      = omega * grid_r(ir) * grid_r(ir)
	      whole_matrix_sph(2,npos)
     &	      = omega * omega
     &	        * (
     &	          dcmplx( submatrix_I0(1,ir)   ) / factor_qkappa(2)
     &	          )
     &	      - dcmplx( lsq2 * submatrix_I1k(1,ir)
     &	                  + submatrix_I2(1,ir)
     &	              )
	    else
	      npos = npos + 1
	      whole_matrix_sph(1,npos)
     &	      = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(2,ir-1) )
     &	        - dcmplx( lsq2 * submatrix_I1k(2,ir-1)
     &	                  + submatrix_I2(2,ir-1)
     &	                )
	      whole_matrix_sph(2,npos)
     &	      = omega * omega
     &	        * (
     &	          dcmplx( submatrix_I0(4,ir-1) ) / factor_qkappa(1)
     &	          + dcmplx( submatrix_I0(1,ir)   ) / factor_qkappa(2)
     &	          )
     &	      - dcmplx( lsq2 * submatrix_I1k(4,ir-1)
     &	                  + submatrix_I2(4,ir-1)
     &	              )
     &	      - dcmplx( lsq2 * submatrix_I1k(1,ir)
     &	                  + submatrix_I2(1,ir)
     &	              )
	    endif
	  else
	    if ( itype_medium.eq.0 ) then
	      npos = npos + 1
	      whole_matrix_sph(1,npos)
     &	      = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(2,ir-1)
     &	                )
     &	        - dcmplx( lsq2 * submatrix_I1k(2,ir-1)
     &	                  + submatrix_I2(2,ir-1)
     &	                )
	      whole_matrix_sph(2,npos)
     &	      = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                )
     &	      - dcmplx( lsq2 * submatrix_I1k(4,ir-1)
     &	                  + submatrix_I2(4,ir-1)
     &	              )
	      npos = npos + 1
	      itype_medium = 1
	      whole_matrix_sph(1,npos)
     &	      = - omega * grid_r(ir) * grid_r(ir)
	      whole_matrix_sph(2,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(1,ir)
     &	                )
     &	        - factor_qkappa(2)
     &	        * dcmplx( submatrix_I1k(1,ir)
     &	                  + 4.d0 * submatrix_I3k(1,ir)
     &	                  + 4.d0 * submatrix_I5k(1,ir)
     &	                )
     &	        - factor_qmu(2)
     &	        * dcmplx( submatrix_I1m(1,ir)
     &	                  + 4.d0 * submatrix_I3m(1,ir)
     &	                  + 4.d0 * submatrix_I5m(1,ir)
     &	                  + lsq2 * submatrix_I6(1,ir)
     &	                  - 4.d0 * submatrix_I7(1,ir)
     &	                )
	    else
	      npos = npos + 1
	      itype_medium = 1
	      whole_matrix_sph(1,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(2,ir-1)
     &	                )
     &	        - factor_qkappa(1)
     &	        * dcmplx( submatrix_I1k(2,ir-1)
     &	                  + 2.d0 * submatrix_I3k(2,ir-1)
     &	                  + 2.d0 * submatrix_I3k(3,ir-1)
     &	                  + 4.d0 * submatrix_I5k(2,ir-1)
     &	                )
     &	        - factor_qmu(1)
     &	        * dcmplx( submatrix_I1m(2,ir-1)
     &	                  + 2.d0 * submatrix_I3m(2,ir-1)
     &	                  + 2.d0 * submatrix_I3m(3,ir-1)
     &	                  + 4.d0 * submatrix_I5m(2,ir-1)
     &	                  + lsq2 * submatrix_I6(2,ir-1)
     &	                  - 4.d0 * submatrix_I7(2,ir-1)
     &	                )
	      whole_matrix_sph(2,npos)
     &	      = omega * omega
     &	        * dcmplx( submatrix_I0(4,ir-1)
     &	                  + submatrix_I0(1,ir)
     &	                )
     &	        - factor_qkappa(1)
     &	        * dcmplx( submatrix_I1k(4,ir-1)
     &	                  + 4.d0 * submatrix_I3k(4,ir-1)
     &	                  + 4.d0 * submatrix_I5k(4,ir-1)
     &	                )
     &	        - factor_qmu(1)
     &	        * dcmplx( submatrix_I1m(4,ir-1)
     &	                  + 4.d0 * submatrix_I3m(4,ir-1)
     &	                  + 4.d0 * submatrix_I5m(4,ir-1)
     &	                  + lsq2 * submatrix_I6(4,ir-1)
     &	                  - 4.d0 * submatrix_I7(4,ir-1)
     &	                )
     &	        - factor_qkappa(2)
     &	        * dcmplx( submatrix_I1k(1,ir)
     &	                  + 4.d0 * submatrix_I3k(1,ir)
     &	                  + 4.d0 * submatrix_I5k(1,ir)
     &	                )
     &	        - factor_qmu(2)
     &	        * dcmplx( submatrix_I1m(1,ir)
     &	                  + 4.d0 * submatrix_I3m(1,ir)
     &	                  + 4.d0 * submatrix_I5m(1,ir)
     &	                  + lsq2 * submatrix_I6(1,ir)
     &	                  - 4.d0 * submatrix_I7(1,ir)
     &	                )
	    endif
	  endif
  120	continue
	factor_qkappa(1)
     &	  = unelastic_factor( dble(omega),grid_qkappa(idim2_sph-1) )
	factor_qmu(1)
     &	  = unelastic_factor( dble(omega),grid_qmu(idim2_sph-1) )
	if ( itype_medium.eq.0 ) then
	  npos = npos + 1
	  whole_matrix_sph(1,npos)
     &	    = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(2,idim2_sph-1)
     &	                )
     &	      - dcmplx( lsq2 * submatrix_I1k(2,idim2_sph-1)
     &	                  + submatrix_I2(2,idim2_sph-1)
     &	              )
	  whole_matrix_sph(2,npos)
     &	      = omega * omega / factor_qkappa(1)
     &	        * dcmplx( submatrix_I0(4,idim2_sph-1)
     &	                )
     &	      - dcmplx( lsq2 * submatrix_I1k(4,idim2_sph-1)
     &	                + submatrix_I2(4,idim2_sph-1)
     &	              )
	  ndim_whole_matrix_sph = npos
	else
	  npos = npos + 1
	  whole_matrix_sph(1,npos)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(2,idim2_sph-1)
     &	              )
     &	    - factor_qkappa(1)
     &	      * dcmplx( submatrix_I1k(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3k(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3k(3,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5k(2,idim2_sph-1)
     &	              )
     &	    - factor_qmu(1)
     &	      * dcmplx( submatrix_I1m(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3m(2,idim2_sph-1)
     &	                + 2.d0 * submatrix_I3m(3,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5m(2,idim2_sph-1)
     &	                + lsq2 * submatrix_I6(2,idim2_sph-1)
     &	                - 4.d0 * submatrix_I7(2,idim2_sph-1)
     &	              )
	  whole_matrix_sph(2,npos)
     &	  = omega * omega
     &	      * dcmplx( submatrix_I0(4,idim2_sph-1)
     &	              )
     &	    - factor_qkappa(1)
     &	      * dcmplx( submatrix_I1k(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I3k(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5k(4,idim2_sph-1)
     &	              )
     &	    - factor_qmu(1)
     &	      * dcmplx( submatrix_I1m(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I3m(4,idim2_sph-1)
     &	                + 4.d0 * submatrix_I5m(4,idim2_sph-1)
     &	                + lsq2 * submatrix_I6(4,idim2_sph-1)
     &	                - 4.d0 * submatrix_I7(4,idim2_sph-1)
     &	              )
	  ndim_whole_matrix_sph = npos
	endif
c **********************************************************************
c computing the wavefield
c **********************************************************************
c imposing fixed boundary conditions at r=0 and free surface boundary
c conditions at the surface
	if ( ( grid_mu(1,idim1_sph)*grid_mu(2,idim1_sph).ne.0.d0 )
     &	     .and.( grid_r(idim1_sph).eq.0.d0 ) ) then
	  init_grid = 2
	else
	  init_grid = 1
	endif
	if ( grid_mu(1,idim2_sph-1)*grid_mu(2,idim2_sph-1).eq.0.d0 )
     &	  then
	  end_grid = ndim_whole_matrix_sph - 1
	else
	  end_grid = ndim_whole_matrix_sph
	endif
	m = 0
	ns = idim_rs_sph - init_grid + 1
	if ( mod(l,100).eq.0 ) then
	  nq = end_grid - init_grid + 1
	else
	  nq = end_grid - idim_station_sph + 1
	endif
	call dclisb(whole_matrix_sph(1,init_grid),
     &	            end_grid - init_grid + 1,
     &	            1,4,ns,nq,whole_vector_sph(init_grid,m),
     &	            eps,whole_matrix_dr_sph(init_grid),
     &	            work_vector(init_grid),ier)
c
	ndim_whole_matrix_tor = 0
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	complex*16 function unelastic_factor( omega,qmu )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing the unelastic factor (ratio between complex mu and
c real mu) for the given quality factor, qmu.
c    required subroutines: none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c input/output variables
	real*8 omega,qmu
c other variables
	real*8 vr,vi
c constants
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
c **********************************************************************
c computing the complex velocity for the given qmu
c **********************************************************************
	if ( (omega.eq.0.d0).or.(qmu.lt.0.d0) ) then
	  vr = 1.d0
	  vi = 0.d0
	else
	  vr = 1.d0
     &	       + dlog( omega / ( 2.d0 * pi ) ) / ( pi * qmu )
	  vi = 1.d0 / ( 2.d0 * qmu )
	endif
c
c **********************************************************************
c computing the unelastic factor
c **********************************************************************
	unelastic_factor = dcmplx( vr, vi ) * dcmplx( vr, vi )
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine dclisb(a, n, nud, n1, np, nq, b, eps, dr, z, ier)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
************************************************************************
*  simultaneous linear equations with real symmetric positive definite *
*      band matrix by cholesky method.                                 *
*  parameters                                                          *
*    (1) a : 2-dim. array containing the matrix.                       *
*    (2) n : order of the matrix.                                      *
*    (3) nud : size of band's half width.                              *
*    (4) n1 : row size of the array a in the 'dimension' statement.    *
*    (5) b : 1-dim. array containing the right hand side vector.       *
*    (6) eps : parameter to check singurarity off the matrix           *
*              standard value = 1.0d-14                                *
*    (7) dr : 1-dim. working array.                                    *
*    (8) z : 1-dim. working array.                                     *
*    (9) ier : error code.                                             *
*  copy right   t. oguni   july 30 1989   version 1.0                  *
************************************************************************
	integer n, nud, n1, np, nq, ier
	complex*16 a(n1,n), b(n), dr(n), z(n)
	real*8 eps
	complex*16 xx, s, sum, au, t
	real*8 eps1
	integer i ,m, j, k1, mj, i1, k, j1
c  check the input data
	ier = 0
	eps1 = 1.0d-14
	m = nud + 1
	if ((n .le. 0) .or. (nud .le. 0 ) .or. (n1 .lt. m)) then
	 ier = 2
	 write(*,*) '(subr. lisb) invalid argument. ', n, nud, n1
	 return
	endif
	if (eps .le. 0.0) eps = eps1
c  modified cholesky decomposition
	j = 1
	if (cdabs(a(m,1)) .le. eps) then
	 ier = 1
	 write(*,*) '(subr. lisb) singular at step # ', j
	 return
	endif
	dr(1) = dcmplx(1.0d0) / a(m,1)
	xx = a(m-1,2)
	a(m-1,2) = a(m-1,2) * dr(1)
	s = a(m,2) - xx * a(m-1,2)
	j = 2
	if (cdabs(s) .le. eps) then
	 ier = 1
	 write(*,*) '(subr. lisb) singular at step # ', j
	 return
	endif
	dr(2) = dcmplx(1.0d0) / s
	if (m .lt. 3) then
	 do 5 j=3,n
	  xx = a(1,j)
	  a(1,j) = xx * dr(j-1)
	  s = a(2,j) - xx * a(1,j)
	  if (cdabs(s) .le. eps) then
	   ier = 1
	   write(*,*) ' (subr. lisb) singular at step # ', j
	   return
	  endif
	  dr(j) = dcmplx(1.0d0) / s
    5	 continue
	else
	 do 30 j=3,n
	  k1 = 1
	  if (j .ge. m) k1 = j - m + 1
	  mj = m - j
	  do 20 i=k1+1,j-1
	   sum = dcmplx(0.0d0)
	   do 10 k=k1,i-1
   10	    sum = sum + a(m-i+k,i) * a(mj+k,j)
	   a(mj+i,j) = a(mj+i,j) - sum
   20	  continue
	  sum = dcmplx(0.0d0)
	  do 25 i=k1,j-1
	   xx = a(mj+i,j)
	   au = xx * dr(i)
	   sum = sum + xx *au
	   a(mj+i,j) = au
   25	  continue
	  t = a(m,j) - sum
	  if (cdabs(t) .le. eps) then
	   ier = 1
	   write(*,*) ' (subr. lisb) singular at step # ', j
	   return
	  endif
	  dr(j) = dcmplx(1.0d0) / t
   30	 continue
	endif
c subtitution
	entry dcsbsub(a, n, nud, n1, np, nq, b, eps, dr, z, ier)
c  forward substitution
	m = nud + 1
	if (m .lt. 3) then
	  z(np) = b(np)
	  do 40 j=np+1,n
   40	  z(j) = b(j) - a(1,j) * z(j-1)
	  do 45 j=1,np-1
   45	  z(j) = dcmplx(0.d0)
	  do 50 j=np,n
   50	  z(j) = z(j) * dr(j)
	  b(n) = z(n)
c	  do 60 j=1,n-1
	  do 60 j=1,nq-1
   60	  b(n-j) = z(n-j) - a(1,n-j+1) * b(n-j+1)
	else
	  z(np) = b(np)
	  z(np+1) = b(np+1) - a(m-1,np+1) * z(np)
	  do 80 j=np+2,n
	    if (j .gt. np-1+m) then
	      i1 = 1
	    else
	      i1 = np-1+m - j + 1
	    endif
	    sum = dcmplx(0.0d0)
	    do 70 k=i1,m-1
   70       sum = sum + a(k,j) * z(j-m+k)
   80	  z(j) = b(j) - sum
	  do 85 j=1,np-1
   85	  z(j) = dcmplx(0.d0)
	  do 90 j=np,n
   90	  z(j) = z(j) * dr(j)
c
	  b(n) = z(n)
	  b(n-1) = z(n-1) - a(m-1,n) * z(n)
	  do 110 j=3,nq
	    j1 = n - j + 1
	    i1 = 1
	    if (j .lt. m) i1 = m - j + 1
	    sum = dcmplx(0.0d0)
	    do 100 k=i1,m-1
  100	    sum = sum + a(k,m-k+j1) * b(m-k+j1)
	    b(j1) = z(j1) - sum
  110	  continue
	endif
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine init_complex_array
     &	             ( n_station,station_displacement )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c initializing the acculuated displacement at the station.
c    required subroutines: none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer n_station
	complex*16 station_displacement(*)
c other variables
	integer i_station
c
	do 100 i_station=1,n_station
	  station_displacement(i_station) = dcmplx(0.d0)
  100	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_displacement_station
     &	    ( maxngrid_r,maxlmax,whole_vector_tor,whole_vector_sph,
     &	      l,n_station,station_theta,station_phi,
     &	      idim_station_sph,idim_station_tor,
     &	      vecsph_sph1,vecsph_sph2,vecsph_tor,
     &	      station_displacement )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c accumulating the displacement at the station.
c    required subroutines: error_handling,comp_vecsph_tor
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,maxlmax,l,n_station
	integer idim_station_sph,idim_station_tor
	real*8 station_theta(*),station_phi(*)
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
	complex*16 vecsph_sph1(3,0:maxlmax,-2:2,*)
	complex*16 vecsph_sph2(3,0:maxlmax,-2:2,*)
	complex*16 vecsph_tor(3,0:maxlmax,-2:2,*)
	complex*16 station_displacement(3,*)
c other variables
	integer m,i_station,icomp
	real*8 lsq
c
	if ( l.le.0 ) call error_handling(55)
	lsq = dsqrt( dble(l) * dble(l+1) )
	do 200 i_station=1,n_station
c ---- computing the value of the trial functions at the station
	  do 120 m=max0(-l,-2),min0(l,2)
c -------- horizontal dependent part
c	    call comp_vecsph(l,m,
c     &	                     station_theta(i_station),
c     &	                     station_phi(i_station),
c     &	                     vecsph_sph1,vecsph_sph2,vecsph_tor)
c ---- computing the displacement at the station
	    do 110 icomp=1,3
	      station_displacement(icomp,i_station)
     &	      = station_displacement(icomp,i_station)
     &	        + whole_vector_sph(idim_station_sph,m)
     &	          * vecsph_sph1(icomp,l,m,i_station)
     &	        + whole_vector_sph(idim_station_sph+1,m)
     &	          * vecsph_sph2(icomp,l,m,i_station) / dcmplx( lsq )
     &	        + whole_vector_tor(idim_station_tor,m)
     &	          * vecsph_tor(icomp,l,m,i_station) / dcmplx( lsq )
  110	    continue
  120	  continue
  200	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_displacement_station0
     &	    ( maxngrid_r,maxlmax,whole_vector_tor,whole_vector_sph,
     &	      l,n_station,station_theta,station_phi,
     &	      idim_station_sph,idim_station_tor,
     &	      vecsph_sph1,vecsph_sph2,vecsph_tor,
     &	      station_displacement )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c accumulating the displacement at the station.
c    required subroutines: error_handling,comp_vecsph_tor
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,maxlmax,l,n_station
	integer idim_station_sph,idim_station_tor
	real*8 station_theta(*),station_phi(*)
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
	complex*16 vecsph_sph1(3,0:maxlmax,-2:2,*)
	complex*16 vecsph_sph2(3,0:maxlmax,-2:2,*)
	complex*16 vecsph_tor(3,0:maxlmax,-2:2,*)
	complex*16 station_displacement(3,*)
c other variables
	integer m,i_station,icomp
	real*8 lsq
c
	if ( l.ne.0 ) call error_handling(56)
	lsq = dsqrt( dble(l) * dble(l+1) )
	do 200 i_station=1,n_station
c ---- computing the value of the trial functions at the station
	  do 120 m=max0(-l,-2),min0(l,2)
c -------- horizontal dependent part
c	    call comp_vecsph(l,m,
c     &	                     station_theta(i_station),
c     &	                     station_phi(i_station),
c     &	                     vecsph_sph1,vecsph_sph2,vecsph_tor)
c ---- computing the displacement at the station
	    do 110 icomp=1,3
	      station_displacement(icomp,i_station)
     &	      = station_displacement(icomp,i_station)
     &	        + whole_vector_sph(idim_station_sph,m)
     &	          * vecsph_sph1(icomp,l,m,i_station)
  110	    continue
  120	  continue
  200	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_vecsph_station
     &	  ( maxlmax,lmax,n_station,station_theta,station_phi,
     &	    vecsph_sph1,vecsph_sph2,vecsph_tor )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxlmax,lmax,n_station
	real*8 station_theta(*),station_phi(*)
	complex*16 vecsph_sph1(3,0:maxlmax,-2:2,*)
	complex*16 vecsph_sph2(3,0:maxlmax,-2:2,*)
	complex*16 vecsph_tor(3,0:maxlmax,-2:2,*)
c other variables
	integer i_station
c
	if ( lmax.gt.maxlmax ) call error_handling(40)
c
	do 100 i_station=1,n_station
	  call  comp_vecsph_all
     &	  ( maxlmax,lmax,
     &	    station_theta(i_station),station_phi(i_station),
     &	    vecsph_sph1(1,0,-2,i_station),
     &	    vecsph_sph2(1,0,-2,i_station),
     &	    vecsph_tor(1,0,-2,i_station) )
  100	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_vecsph_all
     &	  (maxlmax,lmax,theta,phi,vecsph_sph1,vecsph_sph2,vecsph_tor)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing the vector spherical harmonics.
c   required subroutines: error_handling
c   required functions: plgndr
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxlmax,lmax
	real*8 theta,phi
	complex*16 vecsph_sph1(3,0:maxlmax,-2:2)
	complex*16 vecsph_sph2(3,0:maxlmax,-2:2)
	complex*16 vecsph_tor(3,0:maxlmax,-2:2)
c other variables
	integer i,l,m,m0
	real*8 factor,x,plgndr
	complex*16 expimp
c constant
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
	do 300 l=0,lmax
	do 200 m=max0(-l,-2),min0(l,2)
c **********************************************************************
c checking the argumants
c **********************************************************************
	m0 = iabs(m)
	if ( (l.lt.0).or.(m0.gt.l) ) call error_handling(41)
c **********************************************************************
c computing the normalization factor (including the sign)
c **********************************************************************
c
	factor = 1.d0
	do 100 i=l-m0+1,l+m0
	  factor = factor * dble(i)
  100	continue
	factor = dsqrt( dble(2*l+1)/(4.d0*pi) / factor )
	if ( ( m0.ne.m ).and.( mod(m0,2).eq.1 ) ) factor = - factor
c **********************************************************************
c computing each component of the vector spherical harmonics
c **********************************************************************
	x = dcos(theta)
	expimp = cdexp( dcmplx( 0.d0, dble(m)*phi ) )
c
	vecsph_sph1(1,l,m) = factor
     &	                     * plgndr(l,m0,dcos(theta))
     &	                     * expimp
	vecsph_sph1(2,l,m) = 0.d0
	vecsph_sph1(3,l,m) = 0.d0
c
	vecsph_sph2(1,l,m) = 0.d0
	if ( l.ge.m0+1 ) then
	  vecsph_sph2(2,l,m) = factor
     &	                       * (   dble(m0) * x / dsin(theta)
     &	                             * plgndr(l,m0,x)
     &	                          + plgndr(l,m0+1,x) )
     &	                       * expimp
	else
	  vecsph_sph2(2,l,m) = factor
     &	                       * (   dble(m0) * x / dsin(theta)
     &	                             * plgndr(l,m0,x) )
     &	                       * expimp
	endif
	vecsph_sph2(3,l,m) = factor
     &	                     * dcmplx( 0.d0, dble(m) ) / dsin(theta)
     &	                     * plgndr(l,m0,dcos(theta))
     &	                     * expimp
c
	vecsph_tor(1,l,m) = dcmplx(0.d0)
	vecsph_tor(2,l,m) = vecsph_sph2(3,l,m)
	vecsph_tor(3,l,m) = - vecsph_sph2(2,l,m)
c
  200	continue
  300	continue
c	vecsph_tor(2) = factor
c     &	                * dcmplx( 0.d0, dble(m0) ) / dsin(theta)
c     &	                * plgndr(l,m0,dcos(theta))
c     &	                * expimp
c	if ( l.ge.m0+1 ) then
c	  vecsph_tor(3) = - factor
c     &	                  * (   dble(m0) * x / dsin(theta)
c     &	                        * plgndr(l,m0,x)
c     &	                      + plgndr(l,m0+1,x) )
c     &	                  * expimp
c	else
c	  vecsph_tor(3) = - factor
c     &	                  * (   dble(m) * x / dsin(theta)
c     &	                        * plgndr(l,m0,x) )
c     &	                  * expimp
c	endif
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 function plgndr(l,m,x)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing the associated Legendre polynominal
c   (from Numerical Recipies).
c   required subroutines: error_handling
c   required functions: plgndr
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	integer l,m
	real*8 x
	integer i,ll
	real*8 fact,pll,pmm,pmmp1,somx2
c
	if(m.lt.0.or.m.gt.l.or.abs(x).gt.1.) call error_handling(42)
	pmm=1.d0
	if(m.gt.0) then
	  somx2=dsqrt((1.d0-x)*(1.d0+x))
	  fact=1.d0
	  do 11 i=1,m
	    pmm=-pmm*fact*somx2
	    fact=fact+2.d0
11	  continue
	endif
	if(l.eq.m) then
	  plgndr=pmm
	else
	  pmmp1=x*dble(2*m+1)*pmm
	  if(l.eq.m+1) then
	    plgndr=pmmp1
	  else
	    do 12 ll=m+2,l
	      pll=(x*dble(2*ll-1)*pmmp1-dble(ll+m-1)*pmm)/dble(ll-m)
	      pmm=pmmp1
	      pmmp1=pll
12	    continue
	    plgndr=pll
	  endif
	endif
c
	return
	end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_submatrix_mod
     &	  ( ngrid_r,grid_r,
     &	    grid_rho,grid_kappa,grid_mu,
     &	    grid_Ak,grid_Am,grid_L,grid_N,grid_Fk,grid_Fm,
     &	    submatrix_I0,submatrix_I1k,submatrix_I3k,
     &	    submatrix_I3m,submatrix_I4,submatrix_I5k,
     &	    submatrix_I5m,submatrix_I6,submatrix_I7,
     &	    submatrix_I3k_mod,submatrix_I3m_mod,submatrix_I4_mod )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing modified submatrices for elastic part of the medium.
c    required subroutines: none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer ngrid_r
	real*8 grid_r(*)
	real*8 grid_rho(2,*),grid_kappa(2,*),grid_mu(2,*)
	real*8 grid_Ak(2,*),grid_Am(2,*),grid_L(2,*)
	real*8 grid_N(2,*),grid_Fk(2,*),grid_Fm(2,*)
	real*8 submatrix_I0(4,*),submatrix_I1k(4,*)
	real*8 submatrix_I3k(4,*),submatrix_I3m(4,*),submatrix_I4(4,*)
	real*8 submatrix_I5k(4,*),submatrix_I5m(4,*)
	real*8 submatrix_I6(4,*),submatrix_I7(4,*)
	real*8 submatrix_I3k_mod(6,*),submatrix_I3m_mod(6,*)
	real*8 submatrix_I4_mod(6,*)
c variables for numerical integrations
	integer ns
c	parameter ( ns = 6 )
	parameter ( ns = 128 )
	integer ir,iy
	real*8 y,r,dr,rhor(0:2*ns),laminvr(0:2*ns),rhoinv(0:2*ns)
	real*8 Fkr(0:2*ns),Fmr(0:2*ns),Lr(0:2*ns)
	real*8 Ak(0:2*ns),Am(0:2*ns),L(0:2*ns),N(0:2*ns)
	real*8 rhor_ave,laminvr_ave,rhoinv_ave
	real*8 Fkr_ave,Fmr_ave,Lr_ave,Ak_ave,Am_ave,L_ave,N_ave
c functions for numerical integrations
	real*8 grid_interpolate
	real*8 grid_val1,grid_val2
	grid_interpolate(y,grid_val1,grid_val2)
     &    = grid_val1
     &	    + y * ( grid_val2 - grid_val1 )
c **********************************************************************
c  computing submatrix elements for each cell
c **********************************************************************
	do 990 ir=1,ngrid_r-1
	dr = grid_r(ir+1) - grid_r(ir)
	if ( grid_mu(1,ir)*grid_mu(2,ir).ne.0.d0 ) then
c evaluating the density or elastic constatns at each sub-grid
	  do 100 iy=0,2*ns
	    y = dble(iy) / dble(2*ns)
	    r = ( 1.d0 - y ) * grid_r(ir)
     &	        + y * grid_r(ir+1)
	    rhor(iy)
     &	      = grid_interpolate(y,grid_rho(1,ir),
     &	                           grid_rho(2,ir)  )
     &	        * r * r
	    Fkr(iy)
     &	      = grid_interpolate(y,grid_Fk(1,ir),
     &	                           grid_Fk(2,ir)  )
     &	        * r
	    Fmr(iy)
     &	      = grid_interpolate(y,grid_Fm(1,ir),
     &	                           grid_Fm(2,ir)  )
     &	        * r
	    Lr(iy)
     &	      = grid_interpolate(y,grid_L(1,ir),
     &	                           grid_L(2,ir)  )
     &	        * r
	    Ak(iy)
     &	      = grid_interpolate(y,grid_Ak(1,ir),
     &	                           grid_Ak(2,ir)  )
	    Am(iy)
     &	      = grid_interpolate(y,grid_Am(1,ir),
     &	                           grid_Am(2,ir)  )
	    L(iy)
     &	      = grid_interpolate(y,grid_L(1,ir),
     &	                           grid_L(2,ir)  )
	    N(iy)
     &	      = grid_interpolate(y,grid_N(1,ir),
     &	                           grid_N(2,ir)  )
  100	  continue
c computing lumped parameters
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                rhor,rhor_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                Fkr,Fkr_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                Fmr,Fmr_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                Lr,Lr_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                Ak,Ak_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                Am,Am_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                L,L_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                N,N_ave )
	  rhor_ave = rhor_ave / dr
	  Fkr_ave = Fkr_ave / dr
	  Fmr_ave = Fmr_ave / dr
	  Lr_ave = Lr_ave / dr
	  Ak_ave = Ak_ave / dr
	  Am_ave = Am_ave / dr
	  L_ave = L_ave / dr
	  N_ave = N_ave / dr
c -----------------------------------------------------------
c -------- computing the optimally accurate         ---------
c -------- submatrices                              ---------
c -----------------------------------------------------------
c modified submatrix_I0
	  submatrix_I0(1,ir)
     &	      = submatrix_I0(1,ir) + dr / 12.d0 * rhor_ave
	  submatrix_I0(2,ir)
     &	      = submatrix_I0(2,ir) - dr / 12.d0 * rhor_ave
	  submatrix_I0(3,ir)
     &	      = submatrix_I0(3,ir) - dr / 12.d0 * rhor_ave
	  submatrix_I0(4,ir)
     &	      = submatrix_I0(4,ir) + dr / 12.d0 * rhor_ave
c modified submatrix_I3k_mod
	  submatrix_I3k_mod(1,ir)
     &	      = submatrix_I3k(1,ir) - 1.d0 / 12.d0 * Fkr_ave
	  submatrix_I3k_mod(2,ir)
     &	      = submatrix_I3k(2,ir) + 2.d0 / 12.d0 * Fkr_ave
	  submatrix_I3k_mod(3,ir)
     &	      = submatrix_I3k(3,ir) + 1.d0 / 12.d0 * Fkr_ave
	  submatrix_I3k_mod(4,ir)
     &	      = submatrix_I3k(4,ir) - 2.d0 / 12.d0 * Fkr_ave
	  submatrix_I3k_mod(5,ir) = - 1.d0 / 12.d0 * Fkr_ave
	  submatrix_I3k_mod(6,ir) =   1.d0 / 12.d0 * Fkr_ave
c modified submatrix_I3m_mod
	  submatrix_I3m_mod(1,ir)
     &	      = submatrix_I3m(1,ir) - 1.d0 / 12.d0 * Fmr_ave
	  submatrix_I3m_mod(2,ir)
     &	      = submatrix_I3m(2,ir) + 2.d0 / 12.d0 * Fmr_ave
	  submatrix_I3m_mod(3,ir)
     &	      = submatrix_I3m(3,ir) + 1.d0 / 12.d0 * Fmr_ave
	  submatrix_I3m_mod(4,ir)
     &	      = submatrix_I3m(4,ir) - 2.d0 / 12.d0 * Fmr_ave
	  submatrix_I3m_mod(5,ir) = - 1.d0 / 12.d0 * Fmr_ave
	  submatrix_I3m_mod(6,ir) =   1.d0 / 12.d0 * Fmr_ave
c modified submatrix_I4_mod
	  submatrix_I4_mod(1,ir)
     &	      = submatrix_I4(1,ir) + 1.d0 / 12.d0 * Lr_ave
	  submatrix_I4_mod(2,ir)
     &	      = submatrix_I4(2,ir) - 2.d0 / 12.d0 * Lr_ave
	  submatrix_I4_mod(3,ir)
     &	      = submatrix_I4(3,ir) - 1.d0 / 12.d0 * Lr_ave
	  submatrix_I4_mod(4,ir)
     &	      = submatrix_I4(4,ir) + 2.d0 / 12.d0 * Lr_ave
	  submatrix_I4_mod(5,ir) =   1.d0 / 12.d0 * Lr_ave
	  submatrix_I4_mod(6,ir) = - 1.d0 / 12.d0 * Lr_ave
c modified submatrix_I5k
	  submatrix_I5k(1,ir)
     &	      = submatrix_I5k(1,ir) + dr / 12.d0 * Ak_ave
	  submatrix_I5k(2,ir)
     &	      = submatrix_I5k(2,ir) - dr / 12.d0 * Ak_ave
	  submatrix_I5k(3,ir)
     &	      = submatrix_I5k(3,ir) - dr / 12.d0 * Ak_ave
	  submatrix_I5k(4,ir)
     &	      = submatrix_I5k(4,ir) + dr / 12.d0 * Ak_ave
c modified submatrix_I5m
	  submatrix_I5m(1,ir)
     &	      = submatrix_I5m(1,ir) + dr / 12.d0 * Am_ave
	  submatrix_I5m(2,ir)
     &	      = submatrix_I5m(2,ir) - dr / 12.d0 * Am_ave
	  submatrix_I5m(3,ir)
     &	      = submatrix_I5m(3,ir) - dr / 12.d0 * Am_ave
	  submatrix_I5m(4,ir)
     &	      = submatrix_I5m(4,ir) + dr / 12.d0 * Am_ave
c modified submatrix_I6
	  submatrix_I6(1,ir)
     &	      = submatrix_I6(1,ir) + dr / 12.d0 * L_ave
	  submatrix_I6(2,ir)
     &	      = submatrix_I6(2,ir) - dr / 12.d0 * L_ave
	  submatrix_I6(3,ir)
     &	      = submatrix_I6(3,ir) - dr / 12.d0 * L_ave
	  submatrix_I6(4,ir)
     &	      = submatrix_I6(4,ir) + dr / 12.d0 * L_ave
c modified submatrix_I7
	  submatrix_I7(1,ir)
     &	      = submatrix_I7(1,ir) + dr / 12.d0 * N_ave
	  submatrix_I7(2,ir)
     &	      = submatrix_I7(2,ir) - dr / 12.d0 * N_ave
	  submatrix_I7(3,ir)
     &	      = submatrix_I7(3,ir) - dr / 12.d0 * N_ave
	  submatrix_I7(4,ir)
     &	      = submatrix_I7(4,ir) + dr / 12.d0 * N_ave
	else
	  do 200 iy=0,2*ns
	    y = dble(iy) / dble(2*ns)
	    r = ( 1.d0 - y ) * grid_r(ir)
     &	        + y * grid_r(ir+1)
	    laminvr(iy)
     &	      = r * r
     &	        / grid_interpolate(y,grid_kappa(1,ir),
     &	                             grid_kappa(2,ir)  )
	    rhoinv(iy)
     &	      = 1.d0 / grid_interpolate(y,grid_rho(1,ir),
     &	                                  grid_rho(2,ir)  )
  200	  continue
c computing lumped parameters
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                laminvr,laminvr_ave )
	  call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                rhoinv,rhoinv_ave )
	  laminvr_ave = laminvr_ave / dr
	  rhoinv_ave = rhoinv_ave / dr
c -----------------------------------------------------------
c -------- computing the optimally accurate         ---------
c -------- submatrices                              ---------
c -----------------------------------------------------------
c modified submatrix_I0
	  submatrix_I0(1,ir)
     &	      = submatrix_I0(1,ir) + dr / 12.d0 * laminvr_ave
	  submatrix_I0(2,ir)
     &	      = submatrix_I0(2,ir) - dr / 12.d0 * laminvr_ave
	  submatrix_I0(3,ir)
     &	      = submatrix_I0(3,ir) - dr / 12.d0 * laminvr_ave
	  submatrix_I0(4,ir)
     &	      = submatrix_I0(4,ir) + dr / 12.d0 * laminvr_ave
c modified submatrix_I1k
	  submatrix_I1k(1,ir)
     &	      = submatrix_I1k(1,ir) + dr / 12.d0 * rhoinv_ave
	  submatrix_I1k(2,ir)
     &	      = submatrix_I1k(2,ir) - dr / 12.d0 * rhoinv_ave
	  submatrix_I1k(3,ir)
     &	      = submatrix_I1k(3,ir) - dr / 12.d0 * rhoinv_ave
	  submatrix_I1k(4,ir)
     &	      = submatrix_I1k(4,ir) + dr / 12.d0 * rhoinv_ave
	endif
  990	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine comp_submatrix
     &	    ( ngrid_r,grid_r,
     &	      grid_rho,grid_kappa,grid_mu,grid_Ak,grid_Am,
     &	      grid_Ck,grid_Cm,grid_L,grid_N,grid_Fk,grid_Fm,
     &	      submatrix_I0,submatrix_I1k,submatrix_I1m,submatrix_I2,
     &	      submatrix_I3k,submatrix_I3m,submatrix_I4,submatrix_I5k,
     &	      submatrix_I5m,submatrix_I6,submatrix_I7 )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing submatrices for elastic part of the medium.
c    required subroutines: none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer ngrid_r
	real*8 grid_r(*)
	real*8 grid_rho(2,*),grid_kappa(2,*),grid_mu(2,*)
	real*8 grid_Ak(2,*),grid_Am(2,*),grid_Ck(2,*),grid_Cm(2,*)
	real*8 grid_L(2,*),grid_N(2,*),grid_Fk(2,*),grid_Fm(2,*)
	real*8 submatrix_I0(4,*),submatrix_I1k(4,*),submatrix_I1m(4,*)
	real*8 submatrix_I2(4,*),submatrix_I3k(4,*),submatrix_I3m(4,*)
	real*8 submatrix_I4(4,*),submatrix_I5k(4,*),submatrix_I5m(4,*)
	real*8 submatrix_I6(4,*),submatrix_I7(4,*)
c variables for numerical integrations
	integer ns
c	parameter ( ns = 6 )
	parameter ( ns = 128 )
	integer ir,iy,ib
	real*8 y,yw(2),dyw(2),r
	real*8 rho0,lambda0,Ck0,Cm0,L0,Fk0,Fm0,Ak0,Am0,N0
	real*8 val_integrand0(0:2*ns,4)
	real*8 val_integrand1k(0:2*ns,4)
	real*8 val_integrand1m(0:2*ns,4)
	real*8 val_integrand2(0:2*ns,4)
	real*8 val_integrand3k(0:2*ns,4)
	real*8 val_integrand3m(0:2*ns,4)
	real*8 val_integrand4(0:2*ns,4)
	real*8 val_integrand5k(0:2*ns,4)
	real*8 val_integrand5m(0:2*ns,4)
	real*8 val_integrand6(0:2*ns,4)
	real*8 val_integrand7(0:2*ns,4)
c functions for numerical integrations
	real*8 grid_interpolate,C0,F0,A0
	real*8 sub_integrand0,sub_integrand1,sub_integrand2
	real*8 sub_integrand3,sub_integrand4,sub_integrand5
	real*8 sub_integrand6,sub_integrand7
	real*8 sub_integrandF0,sub_integrandF1,sub_integrandF2
	real*8 y1,dy1,y2,dy2
	real*8 grid_val1,grid_val2
	grid_interpolate(y,grid_val1,grid_val2)
     &    = grid_val1
     &	    + y * ( grid_val2 - grid_val1 )
	sub_integrand0(rho0,y1,dy1,y2,dy2,r)
     &	  = y1 * r * rho0 * y2 * r
	sub_integrand1(C0,y1,dy1,y2,dy2,r)
     &	  = dy1 * r * C0 * dy2 * r
	sub_integrand2(L0,y1,dy1,y2,dy2,r)
     &	  = dy1 * r * L0 * dy2 * r
	sub_integrand3(F0,y1,dy1,y2,dy2,r)
     &	  = y1 * F0 * dy2 * r
	sub_integrand4(L0,y1,dy1,y2,dy2,r)
     &	  = dy1 * r * L0 * y2
	sub_integrand5(A0,y1,dy1,y2,dy2,r)
     &	  = y1 * A0 * y2
	sub_integrand6(L0,y1,dy1,y2,dy2,r)
     &	  = y1 * L0 * y2
	sub_integrand7(N0,y1,dy1,y2,dy2,r)
     &	  = y1 * N0 * y2
	sub_integrandF0(lambda0,y1,dy1,y2,dy2,r)
     &	  = y1 * r / lambda0 * y2 * r
	sub_integrandF1(rho0,y1,dy1,y2,dy2,r)
     &	  = y1 / rho0 * y2
	sub_integrandF2(rho0,y1,dy1,y2,dy2,r)
     &	  = dy1 * r / rho0 * dy2 * r
c **********************************************************************
c  computing stiffness submatrix elements for each cell
c **********************************************************************
	do 990 ir=1,ngrid_r-1
	if ( grid_mu(1,ir)*grid_mu(2,ir).ne.0.d0 ) then
c -----------------------------------------------------------
c --------  evaluating the stiffness and            ---------
c --------  the integrated function for stiffness   ---------
c --------  matrix at the sub-grids                 ---------
c -----------------------------------------------------------
	  do 110 iy=0,2*ns
	    y = dble(iy) / dble(2*ns)
	    r = ( 1.d0 - y ) * grid_r(ir)
     &	        + y * grid_r(ir+1)
	    rho0 = grid_interpolate(y,grid_rho(1,ir),grid_rho(2,ir) )
	    Ck0 = grid_interpolate(y,grid_Ck(1,ir),grid_Ck(2,ir) )
	    Cm0 = grid_interpolate(y,grid_Cm(1,ir),grid_Cm(2,ir) )
	    L0 = grid_interpolate(y,grid_L(1,ir),grid_L(2,ir) )
	    Fk0 = grid_interpolate(y,grid_Fk(1,ir),grid_Fk(2,ir) )
	    Fm0 = grid_interpolate(y,grid_Fm(1,ir),grid_Fm(2,ir) )
	    Ak0 = grid_interpolate(y,grid_Ak(1,ir),grid_Ak(2,ir) )
	    Am0 = grid_interpolate(y,grid_Am(1,ir),grid_Am(2,ir) )
	    N0 = grid_interpolate(y,grid_N(1,ir),grid_N(2,ir) )
	    yw(1) = 1.d0 - y
	    yw(2) = y
	    dyw(1) = - 1.d0 / ( grid_r(ir+1)
     &	                        - grid_r(ir) )
	    dyw(2) =   1.d0 / ( grid_r(ir+1)
     &	                        - grid_r(ir) )
	    do 100 ib=1,4
	      val_integrand0(iy,ib)
     &	        = sub_integrand0( rho0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand1k(iy,ib)
     &	        = sub_integrand1( Ck0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand1m(iy,ib)
     &	        = sub_integrand1( Cm0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand2(iy,ib)
     &	        = sub_integrand2( L0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand3k(iy,ib)
     &	        = sub_integrand3( Fk0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand3m(iy,ib)
     &	        = sub_integrand3( Fm0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand4(iy,ib)
     &	        = sub_integrand4( L0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand5k(iy,ib)
     &	        = sub_integrand5( Ak0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand5m(iy,ib)
     &	        = sub_integrand5( Am0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand6(iy,ib)
     &	        = sub_integrand6( L0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
	      val_integrand7(iy,ib)
     &	        = sub_integrand7( N0,
     &	                          yw((ib+1)/2),dyw((ib+1)/2),
     &	                          yw(mod(ib+1,2)+1),
     &	                          dyw(mod(ib+1,2)+1),
     &	                          r )
  100	    continue
  110	  continue
c -----------------------------------------------------------
c -------- integrating function_stiffness to obtain ---------
c -------- conventional stiffness matrix            ---------
c -----------------------------------------------------------
	  do 120 ib=1,4
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand0(0,ib),submatrix_I0(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand1k(0,ib),submatrix_I1k(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand1m(0,ib),submatrix_I1m(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand2(0,ib),submatrix_I2(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand3k(0,ib),submatrix_I3k(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand3m(0,ib),submatrix_I3m(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand4(0,ib),submatrix_I4(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand5k(0,ib),submatrix_I5k(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand5m(0,ib),submatrix_I5m(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand6(0,ib),submatrix_I6(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand7(0,ib),submatrix_I7(ib,ir) )
  120	  continue
	else
	  do 210 iy=0,2*ns
	    y = dble(iy) / dble(2*ns)
	    r = ( 1.d0 - y ) * grid_r(ir)
     &	        + y * grid_r(ir+1)
	    rho0 = grid_interpolate(y,grid_rho(1,ir),
     &	                              grid_rho(2,ir) )
	    lambda0 = grid_interpolate(y,grid_kappa(1,ir),
     &	                                 grid_kappa(2,ir) )
	    yw(1) = 1.d0 - y
	    yw(2) = y
	    dyw(1) = - 1.d0 / ( grid_r(ir+1) - grid_r(ir) )
	    dyw(2) =   1.d0 / ( grid_r(ir+1) - grid_r(ir) )
	    do 200 ib=1,4
	      val_integrand0(iy,ib)
     &	        = sub_integrandF0( lambda0,
     &	                           yw((ib+1)/2),dyw((ib+1)/2),
     &	                           yw(mod(ib+1,2)+1),
     &	                           dyw(mod(ib+1,2)+1),
     &	                           r )
	      val_integrand1k(iy,ib)
     &	        = sub_integrandF1( rho0,
     &	                           yw((ib+1)/2),dyw((ib+1)/2),
     &	                           yw(mod(ib+1,2)+1),
     &	                           dyw(mod(ib+1,2)+1),
     &	                           r )
	      val_integrand2(iy,ib)
     &	        = sub_integrandF2( rho0,
     &	                           yw((ib+1)/2),dyw((ib+1)/2),
     &	                           yw(mod(ib+1,2)+1),
     &	                           dyw(mod(ib+1,2)+1),
     &	                           r )
  200	    continue
  210	  continue
c -----------------------------------------------------------
c -------- integrating function_stiffness to obtain ---------
c -------- conventional stiffness matrix            ---------
c -----------------------------------------------------------
	  do 220 ib=1,4
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand0(0,ib),submatrix_I0(ib,ir) )
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand1k(0,ib),submatrix_I1k(ib,ir) )
	    submatrix_I1m(ib,ir) = 0.d0
	    call simpson( ns,grid_r(ir),grid_r(ir+1),
     &	                  val_integrand2(0,ib),submatrix_I2(ib,ir) )
	    submatrix_I3k(ib,ir) = 0.d0
	    submatrix_I3m(ib,ir) = 0.d0
	    submatrix_I4(ib,ir) = 0.d0
	    submatrix_I5k(ib,ir) = 0.d0
	    submatrix_I5m(ib,ir) = 0.d0
	    submatrix_I6(ib,ir) = 0.d0
	    submatrix_I7(ib,ir) = 0.d0
  220	  continue
	endif
c
  990	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine simpson( ns,xs,xe,f,integ )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c integralation by using the Simpson's numerical integral.
c   required subroutines: none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  subroutine simpson(ns,f,integ)
c    ns        :  integer   number of grid intervals
c    xs,xe     :  real*8    start and the end of the integration
c    f(0:2*ns) :  real*8    function values at the nodes
c    integ     :  real*8    the integrated value
c
c                                                    1992.6  N.Takeuchi
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	integer ns
	real*8 xe,xs,f(0:2*ns),integ
	integer i,nn
	real*8 dx,sum,sumo,sume
c
	nn=2*ns
	sum = f(0)+f(nn)
	sumo = 0.d0
	sume = 0.d0
	do 100 i=1,ns-1
	  nn = 2 * i - 1
	  sumo = sumo + f(nn)
	  nn = 2 * i
	  sume = sume + f(nn)
  100	continue
	nn = 2 * ns - 1
	sumo = sumo + f(nn)
	dx = ( xe - xs ) / ( 2.d0 * ns )
	sum = ( sum + 4.d0 * sumo + 2.0 * sume )
     &	         * dx / 3.d0
	integ = sum
c
	return
	end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine mgetd(dv,ml,in)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'read real*8 from message buffer'.
      include 'mpicom.h'
      integer ml,in
      real*8 dv(*)
c
      if ( mbfd.lt.dpos/8+ml ) stop 'mbfd is too small (mgetd).'
c
      call mpi_unpack( dbuff,mbfd*8,dpos,dv,ml,mpi_double_precision,
     1                 mpi_comm_world,in )
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine mgeti(iv,ml,in)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'read integer from message buffer'.
      include 'mpicom.h'
      integer iv(*),ml,in
c
      if ( mbfi.lt.ipos/4+ml ) stop 'mbfi is too small (mgeti).'
c
      call mpi_unpack( ibuff,mbfi*4,ipos,iv,ml,mpi_integer,
     1                 mpi_comm_world,in )
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine minit
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'initiate processes'.
c
c ----------------------------------------------------------------------
c
      include 'mpicom.h'
c
c ----------------------------------------------------------------------
c
      integer in
c
      call mpi_init( in )
      call mpi_comm_rank( mpi_comm_world,rank,in )
      call mpi_comm_size( mpi_comm_world,size,in )
c
      ipos=0
      dpos=0
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine mputd(dv,ml,in)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'write real*8 to message buffer'.
      include 'mpicom.h'
      integer ml,in
      real*8 dv(*)
c
      if ( mbfd.lt.dpos/8+ml ) stop 'mbfd is too small (mputd).'
c
      call mpi_pack( dv,ml,mpi_double_precision,dbuff,mbfd*8,dpos,
     1               mpi_comm_world,in )
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine mputi(iv,ml,in)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'write integer to message buffer'.
      include 'mpicom.h'
      integer iv(*),ml,in
c
      if ( mbfi.lt.ipos/4+ml ) stop 'mbfi is too small (mputi).'
c
      call mpi_pack( iv,ml,mpi_integer,ibuff,mbfi*4,ipos,
     1               mpi_comm_world,in )
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine mrecv(mt,in,ierr)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'receive message'.
c
c ----------------------------------------------------------------------
c
      include 'mpicom.h'
      integer mt,in
      integer ierr,numi,numd,np
c
c ----------------------------------------------------------------------
c
      if ( in.ge.0 ) then
        np=in
        call mpi_recv( param,4,mpi_integer,np,mt+100000,
     1                 mpi_comm_world,status,ierr )
        ipos=0
        dpos=0
        numi=param(1)/4
        numd=param(2)/8
        if( numi.ne.0 ) then
          call mpi_recv( ibuff,numi,mpi_integer,np,mt+110000,
     1                   mpi_comm_world,status,ierr )
        endif
        if( numd.ne.0 ) then
          call mpi_recv( dbuff,numd,mpi_double_precision,np,mt+120000,
     1                   mpi_comm_world,status,ierr )
        endif
      else
        stop 'Invalid arguments (mrecv).'
      endif
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine msend(mn,mt,ierr)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'send message'.
c
c ----------------------------------------------------------------------
c
      include 'mpicom.h'
      integer mn,mt,ierr
      integer np
c
c ----------------------------------------------------------------------
c
      if( mn.lt.0 ) then
        param(1)=ipos
        param(2)=dpos
        do 100 np = 1, size-1
          call mpi_send( param,4,mpi_integer,np,mt+100000,
     1                   mpi_comm_world,ierr )
          if( ipos.ne.0 ) then
            call mpi_send( ibuff,ipos/4,mpi_integer,np,mt+110000,
     1                     mpi_comm_world,ierr )
          endif
          if( dpos.ne.0 ) then
            call mpi_send( dbuff,dpos/8,mpi_double_precision,np,
     1                     mt+120000,mpi_comm_world,ierr )
          endif
  100   continue
      endif
      if( mn.ge.0 ) then
        param(1)=ipos
        param(2)=dpos
        call mpi_send( param,4,mpi_integer,mn,mt+100000,
     1                 mpi_comm_world,ierr )
        if( ipos.ne.0 ) then
          call mpi_send( ibuff,ipos/4,mpi_integer,mn,mt+110000,
     1                   mpi_comm_world,ierr )
        endif
        if( dpos.ne.0 ) then
          call mpi_send( dbuff,dpos/8,mpi_double_precision,mn,
     1                   mt+120000,mpi_comm_world,ierr )
        endif
      endif
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine msndi
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'initialize send buffer'.
c
c ----------------------------------------------------------------------
c
      include 'mpicom.h'
c
c ----------------------------------------------------------------------
c
      ipos=0
      dpos=0
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine mterm
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c        perform function 'exit communication software'.
      include 'mpicom.h'
      integer in
c
      call mpi_finalize(in)
c
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine convspc
     &	 ( max_nstation,maxnfreq,n_station,
     &	   time_series_length,n_frequency,omega_imag,
     &	   station_displacement,
     &	   source_depth,source_lat,source_lon,station_lat,station_lon,
     &	   work_spc,work_time,sac_file )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer max_nstation,maxnfreq,n_frequency,n_station
	real*8 time_series_length,omega_imag
	real*8 source_depth,source_lat,source_lon
	real*8 station_lat(max_nstation),station_lon(max_nstation)
	complex*16 station_displacement(3,max_nstation,maxnfreq)
	real work_time(32*maxnfreq)
	complex*16 work_spc(16*maxnfreq)
	character*80 sac_file(max_nstation)
c other variables
	integer i_station,icomp,i_frequency,ismooth,n1,m1,nn,isign,i
	integer lnblnk
	real*8 t
	character*4 cext(3)
	character*80 outfile
c
	data ismooth / 8 /
	data cext / '.bhz','.bhr','.bht' /
c
	do 1000 i_station=1,n_station
	  do 900 icomp=1,3
	    work_spc(1) = dcmplx(0.d0)
	    do 200 i_frequency=1,n_frequency
	      work_spc(i_frequency+1)
     &	        = station_displacement(icomp,i_station,i_frequency)
  200	    continue
	    do 210 i_frequency=n_frequency+2,ismooth*n_frequency+1
	      work_spc(i_frequency) = dcmplx(0.d0)
  210	    continue
	    do 220 i_frequency=1,ismooth*n_frequency-1
	      n1 = ismooth*n_frequency + i_frequency + 1
	      m1 = ismooth*n_frequency - i_frequency + 1
	      work_spc(n1) = dconjg( work_spc(m1) )
  220	    continue
	    nn = 2 * ismooth*n_frequency
	    isign = 1
	    call four1( work_spc,nn,isign )
	    do 230 i=-nn+1,nn
	      t = time_series_length
     &	                     * dble(i-1) / dble(nn)
	      work_time(i+nn)
     &	        = real(
     &	            dble( work_spc( mod(i-1+nn,nn)+1 ) )
     &	            * dexp( omega_imag * t )
     &	          )
c amplitude correction
c --- for FFT
	      work_time(i+nn) = work_time(i+nn)
     &	                          / real( time_series_length )
c --- km -> m
	      work_time(i+nn) = work_time(i+nn) * 1.e3
  230	    continue
	    outfile
     &	      = sac_file(i_station)(1:lnblnk(sac_file(i_station)))
     &	        //cext(icomp)
	    call sacconv( 2*time_series_length,2*nn,
     &	                  -time_series_length,work_time,
     &	                  source_depth,source_lat,source_lon,
     &	                  station_lat(i_station),station_lon(i_station),
     &	                  icomp,outfile )
  900	  continue
 1000	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine sacconv( tlen,np,b0,y,d0,theta0,phi0,theta,phi,
     &	                    icomp,output )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	include 'header.h'
	include 'equiv.h'
c
	integer np,icomp
	real*8 tlen,b0,d0
	real y(*)
	real*8 theta0,phi0,theta,phi
c variables for files
	character*80 output
c
	call inithdr
	call compprm( tlen,np,b0,
     &	              d0,theta0,phi0,theta,phi,
     &	              begin,delta,npts,stla,stlo,evdp,evla,evlo )
	call wsact0( begin,delta,npts,stla,stlo,evdp,evla,evlo,icomp,
     &	             y,output,
     &	             depmin,depmax,depmen,ennd,
     &	             dist,az,baz,gcarc,cmpaz,cmpinc,
     &	             nvhdr,ninf,nhst,iftype,leven,lovrok,lcalda )
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine compprm( tlen,np,beg0,
     &	                    d0,theta0,phi0,theta,phi,
     &	                    begin,delta,npts,stla,stlo,evdp,evla,evlo )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
	integer np,npts
	real*8 tlen,beg0,d0,theta0,phi0,theta,phi
	real begin,delta,stla,stlo,evdp,evla,evlo
c
	begin = real(beg0)
	npts = np
	delta = tlen / real(npts)
	stla = real( theta )
	stlo = real( phi )
	evdp = real( d0 )
	evla = real( theta0 )
	evlo = real( phi0 )
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine inithdr
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	include 'header.h'
	integer i
c
	do 100 i=1,mfhdr
	  fhdr(i) = -12345.0
  100	continue
	do 110 i=1,mnhdr
	  nhdr(i) = -12345
  110	continue
	do 120 i=1,mihdr
	  ihdr(i) = -12345
  120	continue
	do 130 i=1,mlhdr
	  lhdr(i) = 0
  130	continue
	do 140 i=1,mkhdr
	  khdr(i) = '-12345  '
  140	continue
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine wsact0( begin,delta,npts,stla,stlo,evdp,evla,evlo,
     &	                   icmpt,data,filen,
     &	                   depmin,depmax,depmen,ennd,
     &	                   dist,az,baz,gcarc,cmpaz,cmpinc,
     &	                   nvhdr,ninf,nhst,iftype,leven,lovrok,lcalda )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Generating SAC-binary file for evenly sampled data.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	include 'header.h'
c required variables
	integer npts,icmpt
	real begin,delta,stla,stlo,evdp,evla,evlo,data(*)
	character*80 filen
c computed variables
	real depmin,depmax,depmen,ennd,dist,az,baz,gcarc,cmpaz,cmpinc
	integer nvhdr,ninf,nhst,iftype,leven,lovrok,lcalda
c other variables
	integer i,ier,filenchk,sacbw
c
c	icmpt
c	  3: Transverse Component
c	  otherwise: not supported by this version
c
c
c
	depmax = data(1)
	depmin = data(2)
	depmen = 0.d0
	do 100 i=1,npts
	  if ( data(i).gt.depmax ) depmax = data(i)
	  if ( data(i).lt.depmin ) depmin = data(i)
	  depmen = depmen + data(i)
  100	continue
	depmen = depmen / real(npts)
c
	ennd = begin + delta * real(npts-1)
c
	az = 0.0
	baz = 0.0
	dist = 0.0
	call distaz1( evla,evlo,stla,stlo,1,dist,az,baz,gcarc,ier )
c
	if ( icmpt.eq.1 ) then
	  cmpaz = 0.0
	  cmpinc = 0.0
	else
	if ( icmpt.eq.2 ) then
	  cmpaz = baz + 180.0
	  if ( cmpaz.ge.360.0 ) cmpaz = cmpaz - 360.0
	  cmpinc = 90.0
	else
	if ( icmpt.eq.3 ) then
	  cmpaz = baz + 90.0
	  if ( cmpaz.ge.360.0 ) cmpaz = cmpaz - 360.0
	  cmpinc = 90.0
	else
	  stop 'Illegal component type (wsact0)'
	endif
	endif
	endif
	nvhdr = 6
	ninf = 0
	nhst = 0
	iftype = 1
	leven = 1
	lovrok = 1
	lcalda = 1
c
	ier = filenchk( 80,filen )
	ier = sacbw( mfhdr,mnhdr,mihdr,mlhdr,mkhdr,
     &	             fhdr,nhdr,ihdr,lhdr,khdr,
     &	             npts,data,filen )
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine distaz1(the,phe,ths,phs,ns,dist,az,baz,xdeg,nerr)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
*=====================================================================
* PURPOSE:  To compute the distance and azimuth between locations.
*=====================================================================
* INPUT ARGUMENTS:
*    THE:     Event latitude in decimal degrees, North positive. [r]
*    PHE:     Event longitude, East positive. [r]
*    THS:     Array of station latitudes. [r]
*    PHS:     Array of station longitudes. [r]
*    NS:      Length of THS and PHS. [i]
*=====================================================================
* OUTPUT ARGUMENTS:
*    DIST:    Array of epicentral distances in km. [r]
*    AZ:      Array of azimuths in degrees. [r]
*    BAZ:     Array of back azimuths. [r]
*    XDEG:    Array of great circle arc lengths. [r]
*    NERR:    Error flag:
*             =    0   No error.
*             = 0904   Calculation failed internal consistency checks.
*=====================================================================
* MODULE/LEVEL:  DFM/4
*=====================================================================
* GLOBAL INPUT:
*    MACH:
*=====================================================================
* SUBROUTINES CALLED:
*    SACLIB:  SETMSG, APCMSG
*=====================================================================
* LOCAL VARIABLES:
*=====================================================================
* KNOWN ERRORS:
* - Problem with equation for distance. See discussion below.
*=====================================================================
	real pi,todeg,torad
	parameter (PI=3.141592654)
	parameter (TODEG=57.29577950)
	parameter (TORAD=1./TODEG)
c
	integer ns,nerr,i
	real ths(ns), phs(ns)
	real dist(ns), az(ns), baz(ns), xdeg(ns)
	logical laz,lbaz,ldist,lxdeg
	real the,phe,ec2,onemec2,eps,temp,therad,pherad,thg
	real d,e,f,c,a,b,g,h,thsrad,phsrad
	real d1,e1,f1,c1,a1,b1,g1,h1,sc,sd,ss,t1,p1,t2,p2,el
	real costhi,costhk,sinthi,sinthk,tanthi,tanthk,al,dl
	real a12top,a12bot,a12,cosa12,sina12
	real e2,e3,c0,c2,c4,v1,v2,z1,z2,x2,y2
	real e1p1,sqrte1p1,u1bot,u1,u2top,u2bot,u2,b0,du,pdist
	real rad,fl,twopideg,degtokm
	real c00,c01,c02,c03,c21,c22,c23,c42,c43
* PROCEDURE:
c
* - Calculations are based upon the reference spheroid of 1968 and
*   are defined by the major radius (RAD) and the flattening (FL).
c
      data rad/6378.160/,fl/0.00335293/
      data twopideg/360./
      data c00,c01,c02,c03/1.,0.25,-4.6875e-02,1.953125e-02/
      data c21,c22,c23/-0.125,3.125e-02,-1.46484375e-02/
      data c42,c43/-3.90625e-03,2.9296875e-03/
      data degtokm/111.3199/
c
* - Initialize.
c
      nerr=0
      ec2=2.*fl-fl*fl
      onemec2=1.-ec2
      eps=1.+ec2/onemec2
c
* - Check which output items are required.
c
      laz=.true.
      if(az(1).lt.0.)laz=.false.
      lbaz=.true.
      if(baz(1).lt.0.)lbaz=.false.
      ldist=.true.
      if(dist(1).lt.0.)ldist=.false.
      lxdeg=.true.
      if(xdeg(1).lt.0.)lxdeg=.false.
c
* - Convert event location to radians.
*   (Equations are unstable for latidudes of exactly 0 degrees.)
c
      temp=the
      if(temp.eq.0.)temp=1.0e-08
      therad=torad*temp
      pherad=torad*phe
c
* - Must convert from geographic to geocentric coordinates in order
*   to use the spherical trig equations.  This requires a latitude
*   correction given by: 1-EC2=1-2*FL+FL*FL
c
      thg=atan(onemec2*tan(therad))
      d=sin(pherad)
      e=-cos(pherad)
      f=-cos(thg)
      c=sin(thg)
      a= f*e
      b=-f*d
      g=-c*e
      h=c*d
c
* - Loop on stations:
c
      do 5000 i=1,ns
c
* -- Convert to radians.
        temp=ths(i)
        if(temp.eq.0.)temp=1.0e-08
        thsrad=torad*temp
        phsrad=torad*phs(i)
c
* -- Calculate some trig constants.
        thg=atan(onemec2*tan(thsrad))
        d1=sin(phsrad)
        e1=-cos(phsrad)
        f1=-cos(thg)
        c1=sin(thg)
        a1=f1*e1
        b1=-f1*d1
        g1=-c1*e1
        h1=c1*d1
        sc=a*a1+b*b1+c*c1
c
* - Spherical trig relationships used to compute angles.
c
        if(lxdeg)then
          sd=0.5*sqrt(((a-a1)**2+(b-b1)**2+(c-c1)**2)*((a+a1)**2
     #       +(b+b1)**2+(c+c1)**2))
          xdeg(i)=atan2(sd,sc)*todeg
          if(xdeg(i).lt.0.)xdeg(i)=xdeg(i)+twopideg
        endif
        if(laz)then
          ss = ((a1-d)**2+(b1-e)**2+c1**2-2.)
          sc = ((a1-g)**2+(b1-h)**2+(c1-f)**2-2.)
          az(i)=atan2(ss,sc)*todeg
          if(az(i).lt.0.)az(i)=az(i)+twopideg
        endif
        if(lbaz)then
          ss=((a-d1)**2+(b-e1)**2+c**2-2.)
          sc=((a-g1)**2+(b-h1)**2+(c-f1)**2-2.)
          baz(i)=atan2(ss,sc)*todeg
          if(baz(i).lt.0.)baz(i)=baz(i)+twopideg
        endif
c
* - Now compute the distance between the two points using Rudoe's
*   formula given in GEODESY, section 2.15(b).
*   (There is some numerical problem with the following formulae.
*   If the station is in the southern hemisphere and the event in
*   in the northern, these equations give the longer, not the
*   shorter distance between the two locations.  Since the equations
*   are fairly messy, the simplist solution is to reverse the
*   meanings of the two locations for this case.)
        if(ldist)then
          if(thsrad.gt.0.)then
            t1=thsrad
            p1=phsrad
            t2=therad
            p2=pherad
          else
            t1=therad
            p1=pherad
            t2=thsrad
            p2=phsrad
          endif
          el=ec2/onemec2
          e1=1.+el
          costhi=cos(t1)
          costhk=cos(t2)
          sinthi=sin(t1)
          sinthk=sin(t2)
          tanthi=sinthi/costhi
          tanthk=sinthk/costhk
          al=tanthi/(e1*tanthk)+
     #       ec2*sqrt((e1+tanthi**2)/(e1+tanthk**2))
          dl=p1-p2
          a12top=sin(dl)
          a12bot=(al-cos(dl))*sinthk
          a12=atan2(a12top,a12bot)
          cosa12=cos(a12)
          sina12=sin(a12)
          e1=el*((costhk*cosa12)**2+sinthk**2)
          e2=e1*e1
          e3=e1*e2
          c0=c00+c01*e1+c02*e2+c03*e3
          c2=c21*e1+c22*e2+c23*e3
          c4=c42*e2+c43*e3
          v1=rad/sqrt(1.-ec2*sinthk**2)
          v2=rad/sqrt(1.-ec2*sinthi**2)
          z1=v1*(1.-ec2)*sinthk
          z2=v2*(1.-ec2)*sinthi
          x2=v2*costhi*cos(dl)
          y2=v2*costhi*sin(dl)
          e1p1=e1+1.
          sqrte1p1=sqrt(e1p1)
          u1bot=sqrte1p1*cosa12
          u1=atan2(tanthk,u1bot)
          u2top=v1*sinthk+e1p1*(z2-z1)
          u2bot=sqrte1p1*(x2*cosa12-y2*sinthk*sina12)
          u2=atan2(u2top,u2bot)
          b0=v1*sqrt(1.+el*(costhk*cosa12)**2)/e1p1
          du=u2 -u1
          pdist=b0*(c2*(sin(2.*u2)-sin(2.*u1))+
     #       c4*(sin(4.*u2)-sin(4.*u1)))
          dist(i)=abs(b0*c0*du+pdist)
          if(lxdeg .and. (abs(dist(i)-degtokm*xdeg(i))).gt.100.)then
            nerr=0904
c            call setmsg('ERROR',nerr)
c            call apimsg(i)
          endif
        endif
 5000   continue
c
 8888 return
c
*=====================================================================
* MODIFICATION HISTORY:
*    830603:  Fixed bug with negative station latiudes.
*    810000:  Original version.
*=====================================================================
c
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C-----------------------------------------------------------------------
      SUBROUTINE FOUR1(DATA,NN,ISIGN)
      REAL*8 DATA(*)
      INTEGER NN,ISIGN
      REAL*8 WR,WI,WPR,WPI,WTEMP,THETA
      REAL*8 TEMPR,TEMPI
      INTEGER N,I,J,M,MMAX,ISTEP

      N=2*NN
      J=1
      DO 11 I=1,N,2
        IF(J.GT.I)THEN
          TEMPR=DATA(J)
          TEMPI=DATA(J+1)
          DATA(J)=DATA(I)
          DATA(J+1)=DATA(I+1)
          DATA(I)=TEMPR
          DATA(I+1)=TEMPI
        ENDIF
        M=N/2
1       IF ((M.GE.2).AND.(J.GT.M)) THEN
          J=J-M
          M=M/2
        GO TO 1
        ENDIF
        J=J+M
11    CONTINUE
      MMAX=2
2     IF (N.GT.MMAX) THEN
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/(ISIGN*MMAX)
        WPR=-2.D0*DSIN(0.5D0*THETA)**2
        WPI=DSIN(THETA)
        WR=1.D0
        WI=0.D0
        DO 13 M=1,MMAX,2
          DO 12 I=M,N,ISTEP
            J=I+MMAX
            TEMPR=WR*DATA(J)-WI*DATA(J+1)
            TEMPI=WR*DATA(J+1)+WI*DATA(J)
            DATA(J)=DATA(I)-TEMPR
            DATA(J+1)=DATA(I+1)-TEMPI
            DATA(I)=DATA(I)+TEMPR
            DATA(I+1)=DATA(I+1)+TEMPI
12        CONTINUE
          WTEMP=WR
          WR=WR*WPR-WI*WPI+WR
          WI=WI*WPR+WTEMP*WPI+WI
13      CONTINUE
        MMAX=ISTEP
      GO TO 2
      ENDIF
      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine param_input
     &	  ( maxngrid_r,maxlmax,max_nstation,maxn_structure_zone,
     &	    time_series_length,n_frequency,omega_imag,
     &	    ngrid_r,lmin,lmax,
     &	    n_structure_zone,rmin_structure_zone,rmax_structure_zone,
     &	    rho_structure_zone,vpv_structure_zone,vph_structure_zone,
     &	    vsv_structure_zone,vsh_structure_zone,eta_structure_zone,
     &	    qkappa_structure_zone,qmu_structure_zone,
     &	    source_r,source_mt,source_depth,source_lat,source_lon,
     &	    n_station,station_lat,station_lon,
     &	    station_theta,station_phi,sac_file )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c inputting parameters
c    required subroutines: error_handling,distaz
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,maxlmax,max_nstation,maxn_structure_zone
	integer n_frequency,ngrid_r,lmin,lmax
	integer n_structure_zone,n_station
	real*8 time_series_length,omega_imag
	real*8 rmin_structure_zone(maxn_structure_zone)
	real*8 rmax_structure_zone(maxn_structure_zone)
	real*8 rho_structure_zone(4,maxn_structure_zone)
	real*8 vpv_structure_zone(4,maxn_structure_zone)
	real*8 vph_structure_zone(4,maxn_structure_zone)
	real*8 vsv_structure_zone(4,maxn_structure_zone)
	real*8 vsh_structure_zone(4,maxn_structure_zone)
	real*8 eta_structure_zone(4,maxn_structure_zone)
	real*8 qkappa_structure_zone(maxn_structure_zone)
	real*8 qmu_structure_zone(maxn_structure_zone)
	real*8 source_r,source_mt(3,3)
	real*8 source_depth,source_lat,source_lon
	real*8 station_lat(max_nstation),station_lon(max_nstation)
	real*8 station_theta(max_nstation),station_phi(max_nstation)
	character*80 sac_file(max_nstation)
c other variables
	integer i,nexp,nerr
	real dist,az,baz,xdeg
	character*80 dummy,tmpfile
c constants
	real*8 pi
	parameter ( pi=3.1415926535897932d0 )
c
	data tmpfile / 'work' /
c
c **********************************************************************
c reading input file from the standard input and writing out to the
c temporary file
c **********************************************************************
c opening a temporary file
	open( unit=11, file=tmpfile, status='unknown' )
c writing to the temporary file
  100	continue
	  read(5,110) dummy
  110	  format(a80)
	  if ( dummy(1:1).eq.'c' ) goto 100
	  if ( dummy(1:3).eq.'end' ) goto 120
	  write(11,110) dummy
	  goto 100
  120	continue
c closing the temporary file
	close(11)
c
c **********************************************************************
c reading the parameter from the temporary file
c **********************************************************************
c opening the temporary file
	open( unit=11, file=tmpfile, status='unknown' )
c reading the parameters
c ---- parameters for time series ---
	read(11,*) time_series_length,n_frequency
	read(11,*) omega_imag
c ---- parameters for numerical grids ----
	read(11,*) ngrid_r,lmin,lmax
	if ( ngrid_r.gt.maxngrid_r )
     &	  call error_handling(1)
	if ( lmax.gt.maxlmax )
     &	  call error_handling(3)
c ---- parameters for structure ---
	read(11,*) n_structure_zone
	if ( n_structure_zone.gt.maxn_structure_zone )
     &	  call error_handling(2)
	do 130 i=1,n_structure_zone
	  read(11,*) rmin_structure_zone(i),rmax_structure_zone(i),
     &	             rho_structure_zone(1,i),rho_structure_zone(2,i),
     &	             rho_structure_zone(3,i),rho_structure_zone(4,i)
	  read(11,*) vpv_structure_zone(1,i),vpv_structure_zone(2,i),
     &	             vpv_structure_zone(3,i),vpv_structure_zone(4,i)
	  read(11,*) vph_structure_zone(1,i),vph_structure_zone(2,i),
     &	             vph_structure_zone(3,i),vph_structure_zone(4,i)
	  read(11,*) vsv_structure_zone(1,i),vsv_structure_zone(2,i),
     &	             vsv_structure_zone(3,i),vsv_structure_zone(4,i)
	  read(11,*) vsh_structure_zone(1,i),vsh_structure_zone(2,i),
     &	             vsh_structure_zone(3,i),vsh_structure_zone(4,i)
	  read(11,*) eta_structure_zone(1,i),eta_structure_zone(2,i),
     &	             eta_structure_zone(3,i),eta_structure_zone(4,i),
     &	             qmu_structure_zone(i),qkappa_structure_zone(i)
  130	continue
c ---- parameters for a source ---
	read(11,*) source_depth,source_lat,source_lon
	read(11,*) nexp,
     &	           source_mt(1,1),source_mt(2,2),source_mt(3,3),
     &	           source_mt(1,2),source_mt(1,3),source_mt(2,3)
	source_r = rmax_structure_zone(n_structure_zone)
     &	            - source_depth
	source_mt(1,1) = source_mt(1,1) * ( 10.d0**(nexp-25) )
	source_mt(2,2) = source_mt(2,2) * ( 10.d0**(nexp-25) )
	source_mt(3,3) = source_mt(3,3) * ( 10.d0**(nexp-25) )
	source_mt(1,2) = source_mt(1,2) * ( 10.d0**(nexp-25) )
	source_mt(1,3) = source_mt(1,3) * ( 10.d0**(nexp-25) )
	source_mt(2,3) = source_mt(2,3) * ( 10.d0**(nexp-25) )
	source_mt(2,1) = source_mt(1,2)
	source_mt(3,1) = source_mt(1,3)
	source_mt(3,2) = source_mt(2,3)
c --- parameters for stations ---
	read(11,*) n_station
	if ( n_station.gt.max_nstation ) call error_handling(5)
	do 140 i=1,n_station
	  read(11,*) station_lat(i),station_lon(i)
	  call distaz(real(source_lat),real(source_lon),
     &	              real(station_lat(i)),real(station_lon(i)),
     &	              1,dist,az,baz,xdeg,nerr)
	  station_theta(i) = dble(xdeg) * pi / 180.d0
	  station_phi(i) = ( 180.d0 - dble(az) ) * pi / 180.d0
  140	continue
	do 150 i=1,n_station
	  read(11,'(a80)') sac_file(i)
  150	continue
c closing the temporary file
	close(11)
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine grid_generation
     &	  ( maxngrid_r,ngrid_r0,
     &	    n_structure_zone,rmin_structure_zone,rmax_structure_zone,
     &	    vsv_structure_zone,vsh_structure_zone,
     &	    grid_r,source_r,ngrid_r )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Computing the number and the location of grid points.
c    required subroutines: error_handling
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,ngrid_r0,n_structure_zone,ngrid_r
	real*8 rmin_structure_zone(*),rmax_structure_zone(*)
	real*8 vsv_structure_zone(4,*)
	real*8 vsh_structure_zone(4,*)
	real*8 grid_r(*),source_r
c other variables
	integer ngrid,m_structure_zone
	integer i_zone,itmp,i
	real*8 rmin,rmax,rh
c
c computing the layer number of the top solid layer
	m_structure_zone = 0
	do 100 i_zone=1,n_structure_zone
	  if ( ( ( vsv_structure_zone(1,i_zone).eq.0.d0 ).and.
     &	         ( vsv_structure_zone(2,i_zone).eq.0.d0 ).and.
     &	         ( vsv_structure_zone(3,i_zone).eq.0.d0 ).and.
     &	         ( vsv_structure_zone(4,i_zone).eq.0.d0 )      ).or.
     &	       ( ( vsh_structure_zone(1,i_zone).eq.0.d0 ).and.
     &	         ( vsh_structure_zone(2,i_zone).eq.0.d0 ).and.
     &	         ( vsh_structure_zone(3,i_zone).eq.0.d0 ).and.
     &	         ( vsh_structure_zone(4,i_zone).eq.0.d0 )      ) ) then
	    continue
	  else
	    m_structure_zone = i_zone
	  endif
  100	continue
c
c computing the number and the location of the grid points
	rmin = rmin_structure_zone(1)
	rmax = rmax_structure_zone(n_structure_zone)
	grid_r(1) = rmin
	itmp = 1
	do 210 i_zone=1,n_structure_zone
	  rh = rmax_structure_zone(i_zone) - rmin_structure_zone(i_zone)
	  ngrid = int( dble(ngrid_r0) * rh / ( rmax - rmin ) ) + 1
	  do 200 i=1,ngrid
	    itmp = itmp + 1
	    if ( itmp.gt.maxngrid_r ) call error_handling(11)
	    grid_r(itmp) = rmin_structure_zone(i_zone)
     &	                            + rh * dble(i) / dble( ngrid )
c ------ putting an additional node on the source location
	    if ( itmp.gt.2 ) then
	      if ( ( grid_r(itmp-1).lt.source_r ).and.
     &	           ( source_r.lt.grid_r(itmp) ) ) then
	        if ( itmp+1.gt.maxngrid_r ) call error_handling(11)
	        grid_r(itmp+1) = grid_r(itmp)
	        grid_r(itmp) = source_r
	        itmp = itmp + 1
	        if ( ( i_zone.eq.m_structure_zone ).and.
     &	             ( i.eq.ngrid )                      ) then
	          if ( itmp+1.gt.maxngrid_r ) call error_handling(11)
	          grid_r(itmp+1) = grid_r(itmp)
	          grid_r(itmp) = ( grid_r(itmp) + source_r ) / 2.d0
	          itmp = itmp + 1
	        endif
	      else
		if ( ( i_zone.eq.m_structure_zone ).and.
     &	             ( i.eq.ngrid ).and.
     &	             ( source_r.eq.grid_r(itmp) )        ) then
	          if ( itmp+2.gt.maxngrid_r ) call error_handling(11)
	          source_r = grid_r(itmp-1) * 0.001d0
     &	                       + grid_r(itmp) * 0.999d0
	          grid_r(itmp+2) = grid_r(itmp)
	          grid_r(itmp+1) = ( grid_r(itmp) + source_r ) / 2.d0
	          grid_r(itmp) = source_r
	          itmp = itmp + 2
		endif
	      endif
	    endif
c ------
  200	  continue
  210	continue
c recouting the total number of grid points
	ngrid_r = itmp
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine assign_structure
     &	  ( ngrid_r,grid_r,
     &	    n_structure_zone,rmin_structure_zone,rmax_structure_zone,
     &	    rho_structure_zone,
     &	    vpv_structure_zone,vph_structure_zone,
     &	    vsv_structure_zone,vsh_structure_zone,
     &	    eta_structure_zone,
     &	    qkappa_structure_zone,qmu_structure_zone,
     &	    grid_rho,grid_Ak,grid_Am,grid_Ck,grid_Cm,
     &	    grid_L,grid_N,grid_Fk,grid_Fm,
     &	    grid_kappa,grid_mu,grid_qkappa,grid_qmu,
     &	    idim1_sph,idim2_sph,idim1_tor,idim2_tor )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c assigning the input model to the numerical grids
c    required subroutines: error_handling
c    required function: cal_PREM_structure
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer ngrid_r,n_structure_zone
	integer idim1_sph,idim2_sph,idim1_tor,idim2_tor
	real*8 grid_r(*)
	real*8 rmin_structure_zone(*),rmax_structure_zone(*)
	real*8 rho_structure_zone(4,*)
	real*8 vpv_structure_zone(4,*),vph_structure_zone(4,*)
	real*8 vsv_structure_zone(4,*),vsh_structure_zone(4,*)
	real*8 eta_structure_zone(4,*)
	real*8 qkappa_structure_zone(*),qmu_structure_zone(*)
	real*8 grid_rho(2,*)
	real*8 grid_Ak(2,*),grid_Am(2,*),grid_Ck(2,*),grid_Cm(2,*)
	real*8 grid_L(2,*),grid_N(2,*),grid_Fk(2,*),grid_Fm(2,*)
	real*8 grid_kappa(2,*),grid_mu(2,*)
	real*8 grid_qkappa(*),grid_qmu(*)
c other variables
	integer ir,izone,izone1,izone2
	real*8 rho_r(2),vpv_r(2),vph_r(2),vsv_r(2),vsh_r(2),eta_r(2)
	real*8 A_r(2),C_r(2),L_r(2),N_r(2),F_r(2)
	real*8 kappa_r(2),mu_r(2)
	real*8 cal_PREM_structure
c
	do 500 ir=1,ngrid_r-1
	  izone1 = 0
	  izone2 = 0
	  do 150 izone=1,n_structure_zone
	    if ( rmin_structure_zone(izone).le.grid_r(ir) )
     &	      izone1 = izone
  150	  continue
	  do 160 izone=n_structure_zone,1,-1
	    if ( rmax_structure_zone(izone).ge.grid_r(ir+1) )
     &	      izone2 = izone
  160	  continue
	  rho_r(1)
     &	    = cal_PREM_structure( grid_r(ir),
     &	                          rho_structure_zone(1,izone1) )
	  rho_r(2)
     &	    = cal_PREM_structure( grid_r(ir+1),
     &	                          rho_structure_zone(1,izone2) )
	  vpv_r(1)
     &	    = cal_PREM_structure( grid_r(ir),
     &	                          vpv_structure_zone(1,izone1) )
	  vpv_r(2)
     &	    = cal_PREM_structure( grid_r(ir+1),
     &	                          vpv_structure_zone(1,izone2) )
	  vph_r(1)
     &	    = cal_PREM_structure( grid_r(ir),
     &	                          vph_structure_zone(1,izone1) )
	  vph_r(2)
     &	    = cal_PREM_structure( grid_r(ir+1),
     &	                          vph_structure_zone(1,izone2) )
	  vsv_r(1)
     &	    = cal_PREM_structure( grid_r(ir),
     &	                          vsv_structure_zone(1,izone1) )
	  vsv_r(2)
     &	    = cal_PREM_structure( grid_r(ir+1),
     &	                          vsv_structure_zone(1,izone2) )
	  vsh_r(1)
     &	    = cal_PREM_structure( grid_r(ir),
     &	                          vsh_structure_zone(1,izone1) )
	  vsh_r(2)
     &	    = cal_PREM_structure( grid_r(ir+1),
     &	                          vsh_structure_zone(1,izone2) )
	  eta_r(1)
     &	    = cal_PREM_structure( grid_r(ir),
     &	                          eta_structure_zone(1,izone1) )
	  eta_r(2)
     &	    = cal_PREM_structure( grid_r(ir+1),
     &	                          eta_structure_zone(1,izone2) )
	  A_r(1) = rho_r(1) * vph_r(1) * vph_r(1)
	  A_r(2) = rho_r(2) * vph_r(2) * vph_r(2)
	  C_r(1) = rho_r(1) * vpv_r(1) * vpv_r(1)
	  C_r(2) = rho_r(2) * vpv_r(2) * vpv_r(2)
	  L_r(1) = rho_r(1) * vsv_r(1) * vsv_r(1)
	  L_r(2) = rho_r(2) * vsv_r(2) * vsv_r(2)
	  N_r(1) = rho_r(1) * vsh_r(1) * vsh_r(1)
	  N_r(2) = rho_r(2) * vsh_r(2) * vsh_r(2)
	  F_r(1) = eta_r(1) * ( A_r(1) - 2.d0 * L_r(1) )
	  F_r(2) = eta_r(2) * ( A_r(2) - 2.d0 * L_r(2) )

	  kappa_r(1) = ( 4.d0 * A_r(1) + C_r(1)
     &	                   + 4.d0 * F_r(1) - 4.d0 * N_r(1) ) / 9.d0
	  kappa_r(2) = ( 4.d0 * A_r(2) + C_r(2)
     &	                   + 4.d0 * F_r(2) - 4.d0 * N_r(2) ) / 9.d0
	  mu_r(1) = ( A_r(1) + C_r(1) - 2.d0 * F_r(1)
     &	                + 5.d0 * N_r(1) + 6.d0 * L_r(1) ) / 15.d0
	  mu_r(2) = ( A_r(2) + C_r(2) - 2.d0 * F_r(2)
     &	                + 5.d0 * N_r(2) + 6.d0 * L_r(2) ) / 15.d0
	  grid_rho(1,ir) = rho_r(1)
	  grid_rho(2,ir) = rho_r(2)
	  grid_Ak(1,ir) = A_r(1)
     &	                    * kappa_r(1)
     &	                      / ( kappa_r(1)+4.d0/3.d0*mu_r(1) )
	  grid_Ak(2,ir) = A_r(2)
     &	                    * kappa_r(2)
     &	                      / ( kappa_r(2)+4.d0/3.d0*mu_r(2) )
	  grid_Am(1,ir) = A_r(1)
     &	                    * 4.d0/3.d0*mu_r(1)
     &	                      / ( kappa_r(1)+4.d0/3.d0*mu_r(1) )
	  grid_Am(2,ir) = A_r(2)
     &	                    * 4.d0/3.d0*mu_r(2)
     &	                      / ( kappa_r(2)+4.d0/3.d0*mu_r(2) )
	  grid_Ck(1,ir) = C_r(1)
     &	                    * kappa_r(1)
     &	                      / ( kappa_r(1)+4.d0/3.d0*mu_r(1) )
	  grid_Ck(2,ir) = C_r(2)
     &	                    * kappa_r(2)
     &	                      / ( kappa_r(2)+4.d0/3.d0*mu_r(2) )
	  grid_Cm(1,ir) = C_r(1)
     &	                    * 4.d0/3.d0*mu_r(1)
     &	                      / ( kappa_r(1)+4.d0/3.d0*mu_r(1) )
	  grid_Cm(2,ir) = C_r(2)
     &	                    * 4.d0/3.d0*mu_r(2)
     &	                      / ( kappa_r(2)+4.d0/3.d0*mu_r(2) )
	  grid_L(1,ir) = L_r(1)
	  grid_L(2,ir) = L_r(2)
	  grid_N(1,ir) = N_r(1)
	  grid_N(2,ir) = N_r(2)
	  grid_Fk(1,ir) = F_r(1)
     &	                    * kappa_r(1)
     &	                      / ( kappa_r(1)-2.d0/3.d0*mu_r(1) )
	  grid_Fk(2,ir) = F_r(2)
     &	                    * kappa_r(2)
     &	                      / ( kappa_r(2)-2.d0/3.d0*mu_r(2) )
	  grid_Fm(1,ir) = F_r(1)
     &	                    * (-2.d0/3.d0)*mu_r(1)
     &	                      / ( kappa_r(1)-2.d0/3.d0*mu_r(1) )
	  grid_Fm(2,ir) = F_r(2)
     &	                    * (-2.d0/3.d0)*mu_r(2)
     &	                      / ( kappa_r(2)-2.d0/3.d0*mu_r(2) )
	  grid_kappa(1,ir) = kappa_r(1)
	  grid_kappa(2,ir) = kappa_r(2)
	  grid_mu(1,ir) = mu_r(1)
	  grid_mu(2,ir) = mu_r(2)
	  grid_qkappa(ir)
     &	    = 2.d0/(1.d0/qkappa_structure_zone(izone1)
     &	            +1.d0/qkappa_structure_zone(izone2))
	  grid_qmu(ir)
     &	    = 2.d0/(1.d0/qmu_structure_zone(izone1)
     &	            +1.d0/qmu_structure_zone(izone2))
  500	continue
c --- computing positions of in solution vectors
	idim1_sph = 1
	idim2_sph = ngrid_r
	idim1_tor = 0
	idim2_tor = 0
	do 600 ir=1,ngrid_r-1
	  if ( grid_mu(1,ir)*grid_mu(2,ir).ne.0.d0 ) idim2_tor = ir+1
  600	continue
	if ( idim2_tor.eq.0 ) call error_handling(16)
	do 700 ir=1,idim2_tor-1
	  if ( grid_mu(1,ir)*grid_mu(2,ir).eq.0.d0 ) then
	    idim1_tor = ir
	  endif
  700	continue
	idim1_tor = idim1_tor + 1
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine assign_source
     &	    ( ngrid_r,grid_r,source_r,
     &	      grid_L,grid_Ck,grid_Cm,grid_Fk,grid_Fm,
     &	      grid_qkappa,grid_qmu,grid_mu,
     &	      igrid_rs,grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms,
     &	      grid_qkappas,grid_qmus,
     &	      idim_rs_sph,idim_rs_tor,idim_rs_sph0,idim_rs_tor0 )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing intermediate parameters used in assing source parameters
c to the numerical grids
c    required subroutines: error_handling
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer ngrid_r,igrid_rs
	integer idim_rs_sph,idim_rs_tor,idim_rs_sph0,idim_rs_tor0
	real*8 grid_r(*),source_r
	real*8 grid_L(2,*),grid_Ck(2,*),grid_Cm(2,*)
	real*8 grid_Fk(2,*),grid_Fm(2,*)
	real*8 grid_qkappa(*),grid_qmu(*),grid_mu(2,*)
	real*8 grid_Ls,grid_Cks,grid_Cms,grid_Fks,grid_Fms
	real*8 grid_qkappas,grid_qmus
c other variables
	integer i,ipos1,ipos2,ipos3
c
c ---- serching the grid on the source
	igrid_rs = 0
	do 100 i=1,ngrid_r
	  if ( grid_r(i).eq.source_r ) igrid_rs = i
  100	continue
	if ( igrid_rs.eq.0 ) call error_handling(17)
c ---- computing the elastic constants at the source
	if ( igrid_rs.eq.ngrid_r ) then
	  grid_Ls = grid_L(2,igrid_rs-1)
	  grid_Cks = grid_Ck(2,igrid_rs-1)
	  grid_Cms = grid_Cm(2,igrid_rs-1)
	  grid_Fks = grid_Fk(2,igrid_rs-1)
	  grid_Fms = grid_Fm(2,igrid_rs-1)
	  grid_qkappas = grid_qkappa(igrid_rs-1)
	  grid_qmus = grid_qmu(igrid_rs-1)
	else
	  grid_Ls = grid_L(1,igrid_rs)
	  grid_Cks = grid_Ck(1,igrid_rs)
	  grid_Cms = grid_Cm(1,igrid_rs)
	  grid_Fks = grid_Fk(1,igrid_rs)
	  grid_Fms = grid_Fm(1,igrid_rs)
	  grid_qkappas = grid_qkappa(igrid_rs)
	  grid_qmus = grid_qmu(igrid_rs)
	endif
c --- computing positions of non-zero elements in excitation vectors
	ipos1 = 0
	ipos3 = 0
	ipos2 = 0
	if ( igrid_rs.gt.1 ) then
	  do 200 i=1,igrid_rs-1
	    if ( grid_mu(1,i)*grid_mu(2,i).eq.0.d0 ) then
	      ipos1 = ipos1 + 1
	      ipos3 = ipos3 + 1
	      ipos2 = 0
	    else
	      ipos1 = ipos1 + 2
	      ipos3 = ipos3 + 1
	      ipos2 = ipos2 + 1
	    endif
	    if ( ( grid_mu(2,i).eq.0.d0 ).and.
     &	           ( grid_mu(1,i+1).ne.0.d0 )    ) then
	      ipos1 = ipos1 + 1
	      ipos3 = ipos3 + 1
	      ipos2 = 0
	    endif
	    if ( ( grid_mu(2,i).ne.0.d0 ).and.
     &	           ( grid_mu(1,i+1).eq.0.d0 )    ) then
	      ipos1 = ipos1 + 2
	      ipos3 = ipos3 + 1
	      ipos2 = 0
	    endif
  200	  continue
	endif
	idim_rs_sph = ipos1 + 1
	idim_rs_tor = ipos2 + 1
	idim_rs_sph0 = ipos3 + 1
	idim_rs_tor0 = 0
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine assign_station
     &	    ( ngrid_r,grid_r,grid_mu,
     &	      idim_station_sph,idim_station_tor,
     &	      idim_station_sph0,idim_station_tor0 )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c computing intermediate parameters used in assing station parameters
c    required subroutines: none
c    required function: error_handling
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer ngrid_r
	integer idim_station_sph,idim_station_tor,
     &	        idim_station_sph0,idim_station_tor0
	real*8 grid_r(*),grid_mu(2,*)
c other variables
	integer ir,idim,i,ipos1,ipos2,ipos3
c
	idim = 0
	do 600 ir=1,ngrid_r-1
	  if ( grid_mu(1,ir)*grid_mu(2,ir).ne.0.d0 ) idim = ir
  600	continue
	if ( idim.eq.0 ) call error_handling(18)
c
c --- computing positions of non-zero elements in excitation vectors
	ipos1 = 0
	ipos3 = 0
	ipos2 = 0
	if ( idim.gt.1 ) then
	  do 200 i=1,idim-1
	    if ( grid_mu(1,i)*grid_mu(2,i).eq.0.d0 ) then
	      ipos1 = ipos1 + 1
	      ipos3 = ipos3 + 1
	      ipos2 = 0
	    else
	      ipos1 = ipos1 + 2
	      ipos3 = ipos3 + 1
	      ipos2 = ipos2 + 1
	    endif
	    if ( ( grid_mu(2,i).eq.0.d0 ).and.
     &	           ( grid_mu(1,i+1).ne.0.d0 )    ) then
	      ipos1 = ipos1 + 1
	      ipos3 = ipos3 + 1
	      ipos2 = 0
	    endif
	    if ( ( grid_mu(2,i).ne.0.d0 ).and.
     &	           ( grid_mu(1,i+1).eq.0.d0 )    ) then
	      ipos1 = ipos1 + 2
	      ipos3 = ipos3 + 1
	      ipos2 = 0
	    endif
  200	  continue
	endif
	idim_station_sph = ipos1 + 1 + 2
	idim_station_tor = ipos2 + 1 + 1
	idim_station_sph0 = ipos3 + 1 + 1
	idim_station_tor0 = 0
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 function cal_PREM_structure( r,param )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	real*8 r,param(4)
	real*8 rmax,a
c
	rmax = 6371.d0
	a = r / rmax
	cal_PREM_structure
     &	  = param(1)
     &	    + param(2) * a
     &	    + param(3) * a * a
     &	    + param(4) * a * a * a
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine write_spectrum_file
     &	    ( i_frequency,n_station,spectrum_file,
     &	      station_displacement )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c writing the displacement at each station to the spectrum files.
c   required subroutine: none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer i_frequency,n_station
	character*80 spectrum_file(*)
	complex*16 station_displacement(3,*)
c other variables
	integer i_station
c
	if ( i_frequency.eq.0 ) then
	  do 100 i_station=1,n_station
	    open( unit=11,file=spectrum_file(i_station),
     &	          status='unknown' )
	    write(11,*) i_frequency,
     &	                station_displacement(1,i_station),
     &	                station_displacement(2,i_station),
     &	                station_displacement(3,i_station)
	    close(11)
  100	  continue
	else
	  do 110 i_station=1,n_station
	    open( unit=11,file=spectrum_file(i_station),
     &	          access='append',status='old' )
	    write(11,*) i_frequency,
     &	                station_displacement(1,i_station),
     &	                station_displacement(2,i_station),
     &	                station_displacement(3,i_station)
	    close(11)
  110	  continue
	endif
c
	return
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine distaz(the,phe,ths,phs,ns,dist,az,baz,xdeg,nerr)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
*=====================================================================
* PURPOSE:  To compute the distance and azimuth between locations.
*=====================================================================
* INPUT ARGUMENTS:
*    THE:     Event latitude in decimal degrees, North positive. [r]
*    PHE:     Event longitude, East positive. [r]
*    THS:     Array of station latitudes. [r]
*    PHS:     Array of station longitudes. [r]
*    NS:      Length of THS and PHS. [i]
*=====================================================================
* OUTPUT ARGUMENTS:
*    DIST:    Array of epicentral distances in km. [r]
*    AZ:      Array of azimuths in degrees. [r]
*    BAZ:     Array of back azimuths. [r]
*    XDEG:    Array of great circle arc lengths. [r]
*    NERR:    Error flag:
*             =    0   No error.
*             = 0904   Calculation failed internal consistency checks.
*=====================================================================
* MODULE/LEVEL:  DFM/4
*=====================================================================
* GLOBAL INPUT:
*    MACH:
*=====================================================================
* SUBROUTINES CALLED:
*    SACLIB:  SETMSG, APCMSG
*=====================================================================
* LOCAL VARIABLES:
*=====================================================================
* KNOWN ERRORS:
* - Problem with equation for distance. See discussion below.
*=====================================================================

	real pi,todeg,torad
	parameter (PI=3.141592654)
	parameter (TODEG=57.29577950)
	parameter (TORAD=1./TODEG)
c
	integer ns,nerr,i
	real ths(ns), phs(ns)
	real dist(ns), az(ns), baz(ns), xdeg(ns)
	logical laz,lbaz,ldist,lxdeg
	real the,phe,ec2,onemec2,eps,temp,therad,pherad,thg
	real d,e,f,c,a,b,g,h,thsrad,phsrad
	real d1,e1,f1,c1,a1,b1,g1,h1,sc,sd,ss,t1,p1,t2,p2,el
	real costhi,costhk,sinthi,sinthk,tanthi,tanthk,al,dl
	real a12top,a12bot,a12,cosa12,sina12,e2,e3,c0,c2,c4,v1,v2,z1,z2,x2,y2
	real e1p1,sqrte1p1,u1bot,u1,u2top,u2bot,u2,b0,du,pdist
	real rad,fl,twopideg,degtokm
	real c00,c01,c02,c03,c21,c22,c23,c42,c43
* PROCEDURE:

* - Calculations are based upon the reference spheroid of 1968 and
*   are defined by the major radius (RAD) and the flattening (FL).

      data rad/6378.160/,fl/0.00335293/
      data twopideg/360./
      data c00,c01,c02,c03/1.,0.25,-4.6875e-02,1.953125e-02/
      data c21,c22,c23/-0.125,3.125e-02,-1.46484375e-02/
      data c42,c43/-3.90625e-03,2.9296875e-03/
      data degtokm/111.3199/

* - Initialize.

      nerr=0
      ec2=2.*fl-fl*fl
      onemec2=1.-ec2
      eps=1.+ec2/onemec2

* - Check which output items are required.

      laz=.true.
c      if(az(1).lt.0.)laz=.false.
      lbaz=.true.
c      if(baz(1).lt.0.)lbaz=.false.
      ldist=.true.
c      if(dist(1).lt.0.)ldist=.false.
      lxdeg=.true.
c      if(xdeg(1).lt.0.)lxdeg=.false.

* - Convert event location to radians.
*   (Equations are unstable for latidudes of exactly 0 degrees.)

      temp=the
      if(temp.eq.0.)temp=1.0e-08
      therad=torad*temp
      pherad=torad*phe

* - Must convert from geographic to geocentric coordinates in order
*   to use the spherical trig equations.  This requires a latitude
*   correction given by: 1-EC2=1-2*FL+FL*FL

      thg=atan(onemec2*tan(therad))
      d=sin(pherad)
      e=-cos(pherad)
      f=-cos(thg)
      c=sin(thg)
      a= f*e
      b=-f*d
      g=-c*e
      h=c*d

* - Loop on stations:

      do 5000 i=1,ns

* -- Convert to radians.
        temp=ths(i)
        if(temp.eq.0.)temp=1.0e-08
        thsrad=torad*temp
        phsrad=torad*phs(i)

* -- Calculate some trig constants.
        thg=atan(onemec2*tan(thsrad))
        d1=sin(phsrad)
        e1=-cos(phsrad)
        f1=-cos(thg)
        c1=sin(thg)
        a1=f1*e1
        b1=-f1*d1
        g1=-c1*e1
        h1=c1*d1
        sc=a*a1+b*b1+c*c1

* - Spherical trig relationships used to compute angles.

        if(lxdeg)then
          sd=0.5*sqrt(((a-a1)**2+(b-b1)**2+(c-c1)**2)*((a+a1)**2
     #       +(b+b1)**2+(c+c1)**2))
          xdeg(i)=atan2(sd,sc)*todeg
          if(xdeg(i).lt.0.)xdeg(i)=xdeg(i)+twopideg
        endif
        if(laz)then
          ss = ((a1-d)**2+(b1-e)**2+c1**2-2.)
          sc = ((a1-g)**2+(b1-h)**2+(c1-f)**2-2.)
          az(i)=atan2(ss,sc)*todeg
          if(az(i).lt.0.)az(i)=az(i)+twopideg
        endif
        if(lbaz)then
          ss=((a-d1)**2+(b-e1)**2+c**2-2.)
          sc=((a-g1)**2+(b-h1)**2+(c-f1)**2-2.)
          baz(i)=atan2(ss,sc)*todeg
          if(baz(i).lt.0.)baz(i)=baz(i)+twopideg
        endif

* - Now compute the distance between the two points using Rudoe's
*   formula given in GEODESY, section 2.15(b).
*   (There is some numerical problem with the following formulae.
*   If the station is in the southern hemisphere and the event in
*   in the northern, these equations give the longer, not the
*   shorter distance between the two locations.  Since the equations
*   are fairly messy, the simplist solution is to reverse the
*   meanings of the two locations for this case.)
        if(ldist)then
          if(thsrad.gt.0.)then
            t1=thsrad
            p1=phsrad
            t2=therad
            p2=pherad
          else
            t1=therad
            p1=pherad
            t2=thsrad
            p2=phsrad
          endif
          el=ec2/onemec2
          e1=1.+el
          costhi=cos(t1)
          costhk=cos(t2)
          sinthi=sin(t1)
          sinthk=sin(t2)
          tanthi=sinthi/costhi
          tanthk=sinthk/costhk
          al=tanthi/(e1*tanthk)+
     #       ec2*sqrt((e1+tanthi**2)/(e1+tanthk**2))
          dl=p1-p2
          a12top=sin(dl)
          a12bot=(al-cos(dl))*sinthk
          a12=atan2(a12top,a12bot)
          cosa12=cos(a12)
          sina12=sin(a12)
          e1=el*((costhk*cosa12)**2+sinthk**2)
          e2=e1*e1
          e3=e1*e2
          c0=c00+c01*e1+c02*e2+c03*e3
          c2=c21*e1+c22*e2+c23*e3
          c4=c42*e2+c43*e3
          v1=rad/sqrt(1.-ec2*sinthk**2)
          v2=rad/sqrt(1.-ec2*sinthi**2)
          z1=v1*(1.-ec2)*sinthk
          z2=v2*(1.-ec2)*sinthi
          x2=v2*costhi*cos(dl)
          y2=v2*costhi*sin(dl)
          e1p1=e1+1.
          sqrte1p1=sqrt(e1p1)
          u1bot=sqrte1p1*cosa12
          u1=atan2(tanthk,u1bot)
          u2top=v1*sinthk+e1p1*(z2-z1)
          u2bot=sqrte1p1*(x2*cosa12-y2*sinthk*sina12)
          u2=atan2(u2top,u2bot)
          b0=v1*sqrt(1.+el*(costhk*cosa12)**2)/e1p1
          du=u2 -u1
          pdist=b0*(c2*(sin(2.*u2)-sin(2.*u1))+
     #       c4*(sin(4.*u2)-sin(4.*u1)))
          dist(i)=abs(b0*c0*du+pdist)
          if(lxdeg .and. (abs(dist(i)-degtokm*xdeg(i))).gt.100.)then
            nerr=0904
c            call setmsg('ERROR',nerr)
c            call apimsg(i)
          endif
        endif
 5000   continue

 8888 return

*=====================================================================
* MODIFICATION HISTORY:
*    830603:  Fixed bug with negative station latiudes.
*    810000:  Original version.
*=====================================================================

      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine error_handling(id)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c error handling.
c    required subroutines: none
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	integer id
	integer lnblnk
	character*72 message(99)
c
	message(1) = 'ngrid_r is too large (parameter_input).'
	message(2) = 'n_structure_zone is too large (parameter_input).'
	message(3) = 'lmax is too large (parameter_input).'
	message(5) = 'n_station is too large (parameter_input).'
	message(11) = 'ngrid_r is too large
     & (grid_generation).'
	message(16) = 'Something is wrong (assign_structure).'
	message(17) = 'Something is wrong (assign_source).'
	message(18) = 'Something is wrong (assign_station).'
	message(40) = 'Bad arguments (comp_vecsph_station)'
	message(41) = 'Bad arguments (comp_vecsph_all)'
	message(42) = 'Bad arguments (plgndr)'
	message(51) = 'Bad arguments (comp_excitation)'
	message(51) = 'Bad arguments (comp_excitation0)'
	message(53) = 'Bad arguments (comp_wavefield)'
	message(54) = 'Bad arguments (comp_wavefield0)'
	message(55) = 'Bad arguments (comp_displacement_station)'
	message(56) = 'Bad arguments (comp_displacement_station0)'
c
	write(6,*) '******************** ERROR ********************'
	write(6,*) message(id)(1:lnblnk(message(id)))
	write(6,*) '***********************************************'
	stop
c
	end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine check_amp_significance
     &	  ( maxngrid_r,l,amp_max,i_significance,idim0,
     &	    init_npos_sph,init_npos_tor,
     &	    idim1_sph,idim2_sph,idim1_tor,idim2_tor,
     &	    grid_mu,idim_station_sph,idim_station_tor,
     &	    whole_vector_sph,whole_vector_tor,work_vector )
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c variables for input/output
	integer maxngrid_r,l,i_significance,idim0
	integer init_npos_sph,init_npos_tor
	integer idim1_sph,idim2_sph,idim1_tor,idim2_tor
	integer idim_station_sph,idim_station_tor
	real*8 amp_max,grid_mu(2,*)
	complex*16 whole_vector_sph(2*maxngrid_r,-2:2)
	complex*16 whole_vector_tor(maxngrid_r,-2:2)
	real*8 work_vector(maxngrid_r,2)
c other variables
	integer i,ipos1,ipos2,itmp,idim0_sph,idim0_tor
	real*8 amp,eps,amaxr_sph,amaxr_tor,fac
c
	data eps / 1.d-12 /
c
	if ( mod(l,100).eq.0 ) then
	  if ( l.eq.0 ) then
	    amp_max = cdabs( whole_vector_sph(idim_station_sph,0) )**2
	    i_significance = 1
c
	    ipos1 = 0
	    amaxr_sph = 0.d0
	    amaxr_tor = 0.d0
	    call init_complex_array( maxngrid_r,work_vector )
	    if ( idim2_sph.gt.idim1_sph ) then
c introducing 'fac' to avoid underflow exceptions
	      fac = 1.d100
	      do 100 i=idim1_sph,idim2_sph-1
	        if ( grid_mu(1,i)*grid_mu(2,i).eq.0.d0 ) then
	          ipos1 = ipos1 + 1
	        else
	          ipos1 = ipos1 + 1
	          work_vector(i,1)
     &	            = cdabs( whole_vector_sph(ipos1,0)*fac )**2
	          if ( work_vector(i,1).gt.amaxr_sph )
     &	            amaxr_sph = work_vector(i,1)
	        endif
	        if ( ( grid_mu(2,i).eq.0.d0 ).and.
     &	               ( grid_mu(1,i+1).ne.0.d0 )    ) then
	          ipos1 = ipos1 + 1
	        endif
	        if ( ( grid_mu(2,i).ne.0.d0 ).and.
     &	               ( grid_mu(1,i+1).eq.0.d0 )    ) then
	          ipos1 = ipos1 + 1
	        endif
  100	      continue
	      itmp = idim2_sph
	      do 110 i=idim2_sph-1,idim1_sph,-1
	        if ( grid_mu(1,i)*grid_mu(2,i).eq.0.d0 ) then
	          if ( itmp.eq.i+1 ) itmp = i
	        else
c	          if ( work_vector(i,1).gt.eps*amaxr_sph ) itmp=i
	          if ( work_vector(i,1).ge.eps*amaxr_sph ) itmp=i
	        endif
  110	      continue
	      if ( itmp.ne.idim2_sph ) idim0_sph = itmp
	      if ( idim0_sph.gt.2 ) idim0 = idim0_sph
	    endif
c
	  else
	    amp =
     &	        cdabs( whole_vector_sph(idim_station_sph,  -2) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph+1,-2) )**2
     &	      + cdabs( whole_vector_tor(idim_station_tor,  -2) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph,  -1) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph+1,-1) )**2
     &	      + cdabs( whole_vector_tor(idim_station_tor,  -1) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph,   0) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph+1, 0) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph,   1) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph+1, 1) )**2
     &	      + cdabs( whole_vector_tor(idim_station_tor,   1) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph,   2) )**2
     &	      + cdabs( whole_vector_sph(idim_station_sph+1, 2) )**2
     &	      + cdabs( whole_vector_tor(idim_station_tor,   2) )**2
	    if ( amp.gt.amp_max ) amp_max = amp
	    if ( amp.lt.eps*amp_max ) i_significance = 0
c
	    ipos1 = 0
	    ipos2 = 0
	    amaxr_sph = 0.d0
	    amaxr_tor = 0.d0
	    call init_complex_array( maxngrid_r,work_vector )
	    ipos1 = 0
	    ipos2 = 0
	    if ( idim2_sph.gt.idim1_sph ) then
c introducing 'fac' to avoid underflow exceptions
	      fac = 1.d100
	      do 200 i=idim1_sph,idim2_sph-1
	        if ( grid_mu(1,i)*grid_mu(2,i).eq.0.d0 ) then
	          ipos1 = ipos1 + 1
	        else
	          ipos1 = ipos1 + 2
	          work_vector(i,1)
     &	            =   cdabs( whole_vector_sph(ipos1,  -2)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1+1,-2)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1,  -1)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1+1,-1)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1,   0)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1+1, 0)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1,   1)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1+1, 1)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1,   2)*fac )**2
     &	              + cdabs( whole_vector_sph(ipos1+1, 2)*fac )**2
	          if ( work_vector(i,1).gt.amaxr_sph )
     &	            amaxr_sph = work_vector(i,1)
	        endif
	        if ( ( grid_mu(2,i).eq.0.d0 ).and.
     &	               ( grid_mu(1,i+1).ne.0.d0 )    ) then
	          ipos1 = ipos1 + 1
	        endif
	        if ( ( grid_mu(2,i).ne.0.d0 ).and.
     &	               ( grid_mu(1,i+1).eq.0.d0 )    ) then
	          ipos1 = ipos1 + 2
	        endif
  200	      continue
c
	      do 210 i=idim1_tor,idim2_tor-1
	        ipos2 = ipos2 + 1
	        work_vector(i,2)
     &	          =   cdabs( whole_vector_tor(ipos2,-2)*fac )**2
     &	            + cdabs( whole_vector_tor(ipos2,-1)*fac )**2
     &	            + cdabs( whole_vector_tor(ipos2, 1)*fac )**2
     &	            + cdabs( whole_vector_tor(ipos2, 2)*fac )**2
	        if ( work_vector(i,2).gt.amaxr_tor )
     &	          amaxr_tor = work_vector(i,2)
  210	      continue
c
	      itmp = idim2_sph
	      do 220 i=idim2_sph-1,idim1_sph,-1
	        if ( grid_mu(1,i)*grid_mu(2,i).eq.0.d0 ) then
	          if ( itmp.eq.i+1 ) itmp = i
	        else
c	          if ( work_vector(i,1).gt.eps*amaxr_sph ) itmp=i
	          if ( work_vector(i,1).ge.eps*amaxr_sph ) itmp=i
	        endif
  220	      continue
	      if ( itmp.ne.idim2_sph ) then
	        idim0_sph = itmp
	      else
	        idim0_sph = idim1_sph
	      endif
	      itmp = idim2_tor
	      do 230 i=idim2_tor-1,idim1_tor,-1
c	        if ( work_vector(i,2).gt.eps*amaxr_tor ) itmp=i
	        if ( work_vector(i,2).ge.eps*amaxr_tor ) itmp=i
  230	      continue
	      if ( itmp.ne.idim2_tor ) then
	        idim0_tor = itmp
	      else
	        idim0_tor = idim1_tor
	      endif
	      if ( amaxr_tor.ne.0.d0 ) then
	        if ( ( idim0.lt.min0(idim0_sph,idim0_tor) ).and.
     &	             ( min0(idim0_sph,idim0_tor).gt.2 ) )
     &	          idim0 = min0(idim0_sph,idim0_tor)
	      else
	        if ( idim0_sph.gt.2 )
     &	          idim0 = idim0_sph
	      endif
	    endif
	  endif
c
	  ipos1 = 0
	  ipos2 = 0
	  if ( idim0.gt.1 ) then
	    do 300 i=1,idim0-1
	      if ( grid_mu(1,i)*grid_mu(2,i).eq.0.d0 ) then
	        ipos1 = ipos1 + 1
	        ipos2 = 0
	      else
	        ipos1 = ipos1 + 2
	        ipos2 = ipos2 + 1
	      endif
	      if ( ( grid_mu(2,i).eq.0.d0 ).and.
     &	             ( grid_mu(1,i+1).ne.0.d0 )    ) then
	        ipos1 = ipos1 + 1
	        ipos2 = 0
	      endif
	      if ( ( grid_mu(2,i).ne.0.d0 ).and.
     &	             ( grid_mu(1,i+1).eq.0.d0 )    ) then
	        ipos1 = ipos1 + 2
	        ipos2 = 0
	      endif
  300	    continue
	  endif
	  init_npos_sph = ipos1 + 1
	  if ( idim0.ge.idim1_tor ) then
	    init_npos_tor = ipos2 + 1
	  else
	    init_npos_tor = 1
	  endif
c
	endif
c
	end
